# -*- coding: utf-8 -*-

import _common

class Avatar(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'avatarMetaList',
                'desc': 'item配置表中装饰列表',
                'group': 'Avatar',
                'url': 'webapp/index.php?c=Avatar&a=avatarMetaList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!list', [], '装饰列表(参数见item.xlsx字段)']
                ]
            },{
                'name': 'avatarList',
                'desc': '获取装饰物品列表',
                'group': 'Avatar',
                'url': 'webapp/index.php?c=Avatar&a=avatarList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!list', [_common.AvatarInfo()], '装饰列表']
                ]
            },{
                'name': 'equip',
                'desc': '穿戴装饰物品',
                'group': 'Avatar',
                'url': 'webapp/index.php?c=Avatar&a=equip',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', '', '英雄唯一id'],
                    ['avatar_uniid', '', '装饰唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },{
                'name': 'buyAvatar',
                'desc': '购买装饰物品',
                'group': 'Avatar',
                'url': 'webapp/index.php?c=Avatar&a=buyAvatar',
                'params': [
                    _common.ReqHead(),
                    ['item_id', '', '装饰物品itemId'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'remove',
                'desc': '卸下装饰物品',
                'group': 'Avatar',
                'url': 'webapp/index.php?c=Avatar&a=remove',
                'params': [
                    _common.ReqHead(),
                    ['avatar_uniid', '', '装饰唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },{
                'name': 'clearAvatar',
                'desc': '全部卸下',
                'group': 'Avatar',
                'url': 'webapp/index.php?c=Avatar&a=clearAvatar',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', '', '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
        ]


