# -*- coding: utf-8 -*-

import _common

class BlockChain(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'getTransactionList',
                'desc': '获取列交易列表',
                'group': 'BlockChain',
                'url': 'webapp/index.php?c=BlockChain&a=getTransactionList',
                'params': [
                ],
                'response': [
                    _common.RspHead(),
                    ['!transactions', [_common.NftTransaction()], '交易列表']
                ]
            },
            {
                'name': 'getTransactionInfo',
                'desc': '查看链交易状态',
                'group': 'BlockChain',
                'url': 'webapp/index.php?c=BlockChain&a=getTransactionInfo',
                'params': [
                    ['trans_id', '', '事务id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['data', _common.NftTransaction(), '交易记录']
                ]
            },
            {
                'name': 'reportResult',
                'desc': '上报链调用结果',
                'group': 'BlockChain',
                'url': 'webapp/index.php?c=BlockChain&a=reportResult',
                'params': [
                    ['trans_id', '', '事务id'],
                    ['result', '', '合约返回值'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'name': 'getJumpInfo',
                'desc': '获取跳转信息',
                'group': 'BlockChain',
                'url': 'webapp/index.php?c=BlockChain&a=getJumpInfo',
                'params': [
                    ['trans_id', '', '事务id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['action', 0,'动作 1：特定英雄详情,2：特定枪械详情,3:NFTs芯片列表,4:英雄进阶介面,5:枪械进阶介面,6:芯片升级介面,7:NFTs碎片列表 ,8:目标英雄详情介面的Chip页签,9:目标枪械详情介面的Chip页签 '],
                    ['!params', [''], '参数列表 params[0]: token_id'],
                ]
            },
            {
                'name': 'active721Nft',
                'desc': '激活721nft',
                'group': 'BlockChain',
                'url': 'webapp/index.php?c=BlockChain&a=active721Nft',
                'params': [
                    ['type', 0, '1：英雄 2：枪械 3：芯片'],
                    ['uniid', '', '唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['trans_id', '', '事务id'],
                    ['!params', [''], '合约参数列表'],
                ]
            },
            {
                'name': 'buyDiamond',
                'desc': '购买钻石',
                'group': 'BlockChain',
                'url': 'webapp/index.php?c=BlockChain&a=buyDiamond',
                'params': [
                    _common.ReqHead(),
                    ['token_type', '', "选用币种 目前只支持CEG USDC USDT"],
                    ['num', 0, '购买数量'],
                ],
                'response': [
                    _common.RspHead(),
                    ['trans_id', '', '事务id'],
                    ['!params', [''], '合约参数列表'],
                ]
            },
            {
                'name': 'buyMallProduct',
                'desc': '购买中心化market商品',
                'group': 'BlockChain',
                'url': 'webapp/index.php?c=BlockChain&a=buyMallProduct',
                'params': [
                    _common.ReqHead(),
                    ['goods_uuid', '', '商品唯一id'],
                    ['price', '', '出售价格'],
                ],
                'response': [
                    _common.RspHead(),
                    ['trans_id', '', '事务id'],
                    ['order_id', '', '订单id'],
                    ['!params', [''], '合约参数列表'],
                ]
            },
        ]
