# -*- coding: utf-8 -*-

import _common

class ChipPage(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'chipPageList',
                'desc': '铭文页列表',
                'group': 'ChipPage',
                'url': 'webapp/index.php?c=ChipPage&a=chipPageList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [_common.ChipPageList()], '页列表']
                ]
            },{
                'name': 'showPageInfo',
                'desc': '铭文页信息',
                'group': 'ChipPage',
                'url': 'webapp/index.php?c=ChipPage&a=showPageInfo',
                'params': [
                    _common.ReqHead(),
                    ['page', '', '页id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [_common.ChipPage()], '页信息']
                ]
            },{
                'name': 'setChipPage',
                'desc': '设置铭文页',
                'group': 'ChipPage',
                'url': 'webapp/index.php?c=ChipPage&a=setChipPage',
                'params': [
                    _common.ReqHead(),
                    ['page', '', '页id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'addChipPage',
                'desc': '添加铭文页',
                'group': 'ChipPage',
                'url': 'webapp/index.php?c=ChipPage&a=addChipPage',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'rename',
                'desc': '修改页名',
                'group': 'ChipPage',
                'url': 'webapp/index.php?c=ChipPage&a=rename',
                'params': [
                    _common.ReqHead(),
                    ['page', '', '页id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [_common.ChipPage()], '页信息']
                ]
            },{
                'name': 'useChip',
                'desc': '使用芯片(镶嵌)',
                'group': 'ChipPage',
                'url': 'webapp/index.php?c=ChipPage&a=useChip',
                'params': [
                    _common.ReqHead(),
                    ['page', '', '页id'],
                    ['slot_id', '', '卡槽id'],
                    ['unique_id', '', '芯片idx'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [_common.ChipPage()], '页信息']
                ]
            },{
                'name': 'removeChipOne',
                'desc': '芯片移除',
                'group': 'ChipPage',
                'url': 'webapp/index.php?c=ChipPage&a=removeChipOne',
                'params': [
                    _common.ReqHead(),
                    ['page', '', '页id'],
                    ['slot_id', '', '卡槽id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [_common.ChipPage()], '页信息']
                ]
            },{
                'name': 'removeChipAll',
                'desc': '芯片移除（一键移除）',
                'group': 'ChipPage',
                'url': 'webapp/index.php?c=ChipPage&a=removeChipAll',
                'params': [
                    _common.ReqHead(),
                    ['page', '', '页id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [_common.ChipPage()], '页信息']
                ]
            },
        ]
