# -*- coding: utf-8 -*-

import _common

class DailySelection(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'info',
                'desc': '获取每日精选列表',
                'group': 'DailySelection',
                'url': 'webapp/index.php?c=DailySelection&a=info',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['refresh_count', 0, '刷新次数'],
                    ['refresh_total_count', 0, '可刷新总数)'],
                    ['cost', 0, '每日精选的当前刷新价格，-1表示不可刷新'],
                    ['!goods_list', [_common.DailySelectionGoods()], '每日精选列表'],
                ]
            },
            {
                'name': 'refresh',
                'desc': '刷新每日精选',
                'group': 'DailySelection',
                'url': 'webapp/index.php?c=DailySelection&a=refresh',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['cost', 0, '每日精选的当前刷新价格'],
                ]
            },
            {
                'name': 'buy',
                'desc': '购买每日精选商品',
                'group': 'DailySelection',
                'url': 'webapp/index.php?c=DailySelection&a=buy',
                'params': [
                    _common.ReqHead(),
                    ['grid', 0, '商品在每日精选中的位置索引'],
                    ['token_type', '', "选用币种,只能选择一种"],
                ],
                'response': [
                    _common.RspHead(),
                ]
            }
        ]
