# -*- coding: utf-8 -*-

import _common

class Fragment(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'fragmentList',
                'desc': '获取碎片列表',
                'group': 'Fragment',
                'url': 'webapp/index.php?c=Fragment&a=fragmentList',
                'params': [
                    _common.ReqHead(),
                    ['type', '', '碎片类型：1 英雄；2 枪械'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [_common.Fragment()], '芯片列表']
                ]
            },{
                'name': 'syntheticFragmentPreview',
                'desc': '碎片合成前',
                'group': 'Fragment',
                'url': 'webapp/index.php?c=Fragment&a=syntheticFragmentPreview',
                'params': [
                    _common.ReqHead(),
                    ['type', '', '类型：1 英雄；2 枪械'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!list', [], '英雄或枪械id列表'],
                    ['mint', 0, '费用']
                ]
            },{
                'name': 'syntheticFragment',
                'desc': '碎片合成',
                'group': 'Fragment',
                'url': 'webapp/index.php?c=Fragment&a=syntheticFragment',
                'params': [
                    _common.ReqHead(),
                    ['type', '', '类型：1 英雄；2 枪械'],
                    ['params', '', '普通碎片 item id,用“|”分开；例：item id1|item id2|item id3...'],
                    ['param', '', '特殊碎片 item id'],
                    ['item_id', '', '英雄或枪械 item id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                    ['item_id', 0, '道具id']
                ]
            },{
                'name': 'showBaseByItemId',
                'desc': '查看item的基本信息',
                'group': 'Fragment',
                'url': 'webapp/index.php?c=Fragment&a=showBaseByItemId',
                'params': [
                    _common.ReqHead(),
                    ['item_id', '', '英雄或枪械的道具id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['data', [], '英雄或枪械的基本信息']
                ]
            },

        ]