# -*- coding: utf-8 -*-

import _common

class Hero(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'heroList',
                'desc': '获取英雄列表',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=heroList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!hero_list', [_common.Hero()], '英雄列表']
                ]
            },
            {
                'name': 'skinList',
                'desc': '获取英雄皮肤列表',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=skinList',
                'params': [
                    _common.ReqHead(),
                    ['hero_id', 0, '英雄itemId'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!skin_list', [_common.HeroSkin()], '英雄皮肤列表']
                ]
            },
            {
                'name': 'takeonSkin',
                'desc': '穿戴皮肤',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=takonSkin',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                    ['skin_id', 0, '皮肤id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'name': 'upgradeLevelPreview',
                'desc': '升等级',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=upgradeLevelPreview',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['old_hero', _common.Hero(), '英雄-老'],
                    ['new_hero', _common.Hero(), '英雄-新'],
                    ['cost', _common.Cost(), '所需费用'],
                ]
            },
            {
                'name': 'heroDetails',
                'desc': '英雄详情',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=heroDetails',
                'params': [
                    _common.ReqHead(),
                    ['unique_id', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['!data',  [_common.Hero()], '英雄信息']
                ]
            },
            {
                'name': 'upgradeLv',
                'desc': '升级',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=upgradeLv',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                    ['old_hero', _common.Hero(), '英雄-老'],
                    ['new_hero', _common.Hero(), '英雄-新'],
                ]
            },{
                'name': 'setHeroSkill',
                'desc': '设置通用技能',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=setHeroSkill',
                'params': [
                    _common.ReqHead(),
                    ['skill_id', 0, '技能id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'presetHero',
                'desc': '英雄预设',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=presetHero',
                'params': [
                    _common.ReqHead(),
                    ['hero_uid', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['data', _common.HeroPreset(), '预设信息']
                ]
            },{
                'name': 'applyHero',
                'desc': '应用',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=applyHero',
                'params': [
                    _common.ReqHead(),
                    ['hero_uid', 0, '英雄唯一id'],
                    ['skill_id', 0, '技能itemId'],
                    ['weapon_uid1', 0, '武器1唯一id'],
                    ['weapon_uid2', 0, '武器2唯一id'],
                    ['chip_page', 0, '芯片页id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },{
                'name': 'heroPieceSys',
                'desc': '英雄碎片合成',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=heroPieceSys',
                'params': [
                    _common.ReqHead(),
                    ['item_id', 0, '碎片itemID'],
                ],
                'response': [
                    _common.RspHead(),
                      ['!hero',  [_common.Hero()], '英雄信息']
                ]
            },{
                'name': 'beforeHeroReset',
                'desc': '英雄重置前',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=beforeHeroReset',
                'params': [
                    _common.ReqHead(),
                    ['hero_unnid', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                    ['ceg', 0, 'ceg'],
                    ['!cost', [_common.AwardItem()], '返还资源']
                ]
            },{
                'name': 'heroResetLevel',
                'desc': '英雄重置',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=heroResetLevel',
                'params': [
                    _common.ReqHead(),
                    ['hero_unnid', 0, '英雄唯一id'],
                    ['price', 0, 'ceg数量'],
                ],
                'response': [
                    _common.RspHead(),
                    ['trans_id', 0, '订单号'],
                    ['params', 0, 'params'],
                ]
            },

        ]
