# -*- coding: utf-8 -*-

import _common

class Mall(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'productList',
                'desc': '商品列表',
                'group': 'Mall',
                'url': 'webapp/index.php?c=Mall&a=productList',
                'params': [
                    _common.ReqHead(),
                    ['page', 0, '第几页数据'],
                    ['seller', '', '查询指定钱包 为空的化查询所有人'],
                    ['order_method', 0, '排序方式 0:默认排序(当前指向1) 1:上架时间 2:价格'],
                    ['order_asc', 0, '排序方向, 0:从小到大 1:从大到小'],
                    ['price_filter', '', '价格过滤(用|分割)'],
                ],
                'response': [
                    _common.RspHead(),
                    ['pagination', _common.Pagination(), '分页信息'],
                    ['!rows', [_common.MallGoods()], '商品列表']
                ]
            },
            {
                'name': 'sell',
                'desc': '出售',
                'group': 'Mall',
                'url': 'webapp/index.php?c=Mall&a=sell',
                'params': [
                    _common.ReqHead(),
                    ['item_id', '', '道具id,目前只能卖CEG'],
                    ['amount', '', '出售数量'],
                    ['currency', '', "选用币种 目前只支持CEG USDC USDT"],
                    ['price', '', '出售价格'],
                ],
                'response': [
                    _common.RspHead()
                ]
            },
            {
                'name': 'cancel',
                'desc': '下架物品',
                'group': 'Mall',
                'url': 'webapp/index.php?c=Mall&a=cancel',
                'params': [
                    _common.ReqHead(),
                    ['goods_uuid', '', '商品唯一id'],
                ],
                'response': [
                    _common.RspHead()
                ]
            },
            {
                'name': 'modifyPrice',
                'desc': '修改价格',
                'group': 'Mall',
                'url': 'webapp/index.php?c=Mall&a=modifyPrice',
                'params':[
                    _common.ReqHead(),
                    ['goods_uuid', '', '商品唯一id'],
                    ['price', '', '出售价格USDT'],
                ],
                'response': [
                    _common.RspHead()
                ]
            },
       ]
