# -*- coding: utf-8 -*-

import _common

class Season(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'info',
                'desc': '获取赛季信息',
                'group': 'Season',
                'url': 'webapp/index.php?c=Season&a=info',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['info', _common.Season(), '赛季信息'],
                ]
            },{
                'name': 'getRankingInfo',
                'desc': '获取赛季排行信息',
                'group': 'Season',
                'url': 'webapp/index.php?c=Season&a=getRankingInfo',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!rankList', [_common.SeasonRank()], '赛季排行信息'],
                    ['myRanked', _common.SeasonRank(), '我的排行信息'],
                ]
            },{
                'name': 'getDataInfo',
                'desc': '获取赛季战斗信息',
                'group': 'Season',
                'url': 'webapp/index.php?c=Season&a=getDataInfo',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['info', _common.SeasonData(), '赛季战斗信息'],
                ]
            },{
                'name': 'getSeasonPoint',
                'desc': '获取所有赛季积分获取信息',
                'group': 'Season',
                'url': 'webapp/index.php?c=Season&a=getSeasonPoint',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!data', [SeasonPoint()], '赛季积分信息'],
                ]
            },

        ]

class SeasonPoint(object):

    def __init__(self):
        self.fields = [
            ['season', 0, '赛季'],
            ['ranking', 0, '排名'],
            ['ranking_point', 0, 'SV积分'],
        ]