# -*- coding: utf-8 -*-

import _common

class SeasonCard(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'info',
                'desc': '获取赛季手册信息',
                'group': 'SeasonCard',
                'url': 'webapp/index.php?c=SeasonCard&a=info',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['info', _common.SeasonCard(), '赛季手册信息'],
                ]
            },
            {
                'name': 'getReward',
                'desc': '领取等级奖品',
                'group': 'SeasonCard',
                'url': 'webapp/index.php?c=SeasonCard&a=getReward',
                'params': [
                    _common.ReqHead(),
                    ['type', 0, '1：普通 2：精英'],
                    ['level', 0, '手册等级'],
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
            {
                'name': 'getAllReward',
                'desc': '领取全部等级奖品',
                'group': 'SeasonCard',
                'url': 'webapp/index.php?c=SeasonCard&a=getAllReward',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
            {
                'name': 'buyLevel',
                'desc': '购买赛季手册等级',
                'group': 'SeasonCard',
                'url': 'webapp/index.php?c=SeasonCard&a=buyLevel',
                'params': [
                    _common.ReqHead(),
                    ['add_level', 0, '购买的等级数(是新增值)'],
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
            {
                'name': 'buyGiftPackage',
                'desc': '购买赛季手册(礼包)',
                'group': 'SeasonCard',
                'url': 'webapp/index.php?c=SeasonCard&a=buyGiftPackage',
                'params': [
                    _common.ReqHead(),
                    ['package_id', 0, '礼包id(1：普通礼包 2：豪华礼包)'],
                    ['cost_item_id', 0, '支付方式'],
                ],
                'response': [
                    _common.RspHead(),
                    ['award', _common.Award(), '奖励信息'],
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
        ]
