const app = require('j7/app');
const event = require('j7/event');
const config = require('j7/config');

event.addListener(event.APP_INITIALIZED_EVENT, async () => {
  require('./metadata/factory').init();
  require('./middlewares/factory').init();
  require('./controllers/factory').init();
  require('./models/factory').init();
  require('./services/factory').init();
  require('./tasks/factory').init();
  app.injectionSession(require('./session'));
  app.addStaticDirectory('/static', 'static');
  app.listen(config('listen_port'));
});
app.init();
