const app = require('j7/app');
const utils = require('j7/utils');
const http = require('j7/http');


const constant = require('../constant');
class DailyTask {
    async start() {
        console.log('DailyTask Start ... ');
        let url_star = getUrl('missionStarSeasonSettlement');
        let url_pass = getUrl('battlePassSeasonSettlement');
        let url_ranking = getUrl('battleRankingSeasonSettlement');
        while (true) {
            await  http.get(url_star,null)
            await  http.get(url_pass,null)
            await  http.get(url_ranking,null)
            const nowTime = utils.getUtcTime();
            const daySeconds = utils.getDaySeconds(nowTime, constant.TIME_ZONE);
            const sleepTime = daySeconds + 3600 * 24 - nowTime;
            console.log('DailyTask.sleepTime:' + sleepTime, new Date(), sleepTime / 60);
            await utils.sleep(sleepTime * 1000);
        }
    }
}


function getUrl(action){
    // let url = 'http://james.com/webapp/index.php?&c=DailyRequest&a=' + action;
    let url = '';
    if (utils.isOnlineEnv()) {
        url = 'https://game2006api-test.cebggame.com/webapp/index.php?&c=DailyRequest&a=' + action;
    } else {
        url = 'https://game2006api-test.kingsome.cn/webapp/index.php?&c=DailyRequest&a=' + action;
    }
    return url;
}

function init() {
    (new DailyTask()).start();
}

exports.init = init;