const app = require('j7/app');
const utils = require('j7/utils');
const http = require('j7/http');


const constant = require('../constant');
class HourlyTask {
    async start() {
        console.log('HourlyTask Start ... ');
        while (true) {
            await this.doRewardsCEC()
            // await this.doComputingPower()
            const now = new Date();
            // 计算距离下一个整点的秒数
            const sleepTime = 60 * 60  - (now.getMinutes() * 60 + now.getSeconds()) + 60;
            console.log('HourlyTask.sleepTime:' + sleepTime, new Date(), sleepTime /60);
            await utils.sleep(sleepTime * 1000);
        }
    }

    async doRewardsCEC(){
        let url = '';
        if (utils.isOnlineEnv()) {
            url = 'https://game2006api-test.cebggame.com/webapp/index.php?&c=DailyRequest&a=computingPowerRewards';
        } else {
            url = 'https://game2006api-test.kingsome.cn/webapp/index.php?&c=DailyRequest&a=computingPowerRewards';
        }
        await  http.get(url,null)
    }

    async doComputingPower(){
        try {
            const {err, conn} = await app.getDbConn("GameDb20060");
            if (err){
                throw err
            }
            await this.getPowerTotalNum(conn)
        } catch (err){
            console.log(err);
        }


    }

    async getPowerTotalNum(conn){
        const {err, rows} = await conn.execQuery(
            'select period,sum(total_num) as num from t_power_exchange_record group by period',
            []
        );
        if (err) {
            throw err;
        }
        await utils.serial(rows,
            async (row,index)=> {
                await this.upsertTotalPowerNum(conn,row)
            })

    }


    async upsertTotalPowerNum(conn,row){
        await conn.upsert(
            't_computing_power_period',
            [
                ['period',row.period]
            ],
            [
                ['total_num',row.num]
            ],
            [
                ['period',row.period],
                ['total_num',row.num],
                ['createtime',utils.getUtcTime()],
                ['modifytime',utils.getUtcTime()],
            ]
        )
    }



}


function init() {
    (new HourlyTask()).start();
}

exports.init = init;