begin;

alter table t_transaction add column `item_num` bigint NOT NULL DEFAULT '0' COMMENT '道具num';

CREATE TABLE `t_bc_order` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` varchar(255) COMMENT '订单号',
  `order_type` int(11) NOT NULL COMMENT '0:默认 ',
  `account_id` varchar(60) NOT NULL COMMENT '账户id 只用做事后分析用',
  `address` varchar(60) COMMENT 'address',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT '0: 支付中 1： 已发货',
  `item_id` int(11) NOT NULL COMMENT '道具id',
  `item_num` bigint NOT NULL DEFAULT '0' COMMENT '道具数量',
  `ext_data` mediumblob COMMENT '扩展数据自定义',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `order_id` (`order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

alter table t_shop_buy_order change `account_id` `address` VARCHAR(60) NOT NULL COMMENT '账户地址';
alter table t_first_topup change `account_id` `address` VARCHAR(60) NOT NULL COMMENT '账户地址';

CREATE TABLE `t_shop_dailyselection` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `address` varchar(60) NOT NULL COMMENT 'address',
  `refresh_mode` int(11) NOT NULL COMMENT '0-每日自动刷新时间 1-手动刷新时间',
  `refresh_time` int(11) NOT NULL DEFAULT '0' COMMENT '刷新时间',
  `grid_1` int(11) NOT NULL,
  `grid_2` int(11) NOT NULL,
  `grid_3` int(11) NOT NULL,
  `grid_4` int(11) NOT NULL,
  `grid_5` int(11) NOT NULL,
  `grid_6` int(11) NOT NULL,
  `count_1` tinyint(4) NOT NULL,
  `count_2` tinyint(4) NOT NULL,
  `count_3` tinyint(4) NOT NULL,
  `count_4` tinyint(4) NOT NULL,
  `count_5` tinyint(4) NOT NULL,
  `count_6` tinyint(4) NOT NULL,
  PRIMARY KEY (`idx`) USING BTREE,
  KEY `refresh_time` (`refresh_time`) USING BTREE,
  KEY `address` (`address`) USING HASH,
  KEY `refresh_mode` (`refresh_mode`) USING HASH
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8;

CREATE TABLE `t_shop_free_record` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL COMMENT '账号id',
  `shop_id` int(11) NOT NULL COMMENT '商店id',
  `id` int(11) NOT NULL COMMENT '货架id',
  `goods_id` int(11) NOT NULL COMMENT '道具id',
  `goods_num` int(11) NOT NULL COMMENT '道具数量',
  `free_type` int(11) NOT NULL COMMENT '免费类型',
  `free_num` int(11) NOT NULL COMMENT '免费数量',
  `createtime` int(11) NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`) USING HASH,
  KEY `createtime` (`createtime`) USING BTREE,
  KEY `id` (`id`) USING BTREE,
  KEY `goods_id` (`goods_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=78 DEFAULT CHARSET=utf8;

insert into version (version) values(2023061901);

commit;
