begin;

CREATE TABLE `t_shop_buy_order` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '订单id',
  `address` varchar(60) NOT NULL COMMENT '账户id',
  `createtime` int(11) NOT NULL COMMENT '订单开始时间',
  `id` int(11) NOT NULL COMMENT '商店货物id',
  `item_id` int(11) NOT NULL COMMENT '道具id',
  `goods_num` int(11) NOT NULL COMMENT '购买个数',
  `status` int(11) NOT NULL COMMENT '订单状态 0-客户端申请了订单 1-订单完成 2-订单失败',
  PRIMARY KEY (`idx`)
) ENGINE=InnoDB AUTO_INCREMENT=184 DEFAULT CHARSET=utf8;

CREATE TABLE `t_user_honor` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `address` varchar(60) NOT NULL COMMENT '钱包地址',
  `honor1` int(11) COMMENT 'nft类型6 1:佩戴',
  `honor2` int(11) COMMENT 'honor2',
  `honor3` int(11) COMMENT 'honor3',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `address` (`address`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE `t_web2_order` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `status` int(11) NOT NULL COMMENT '订单状态 0-客户端申请了订单 1-订单完成 2-订单失败',
  `order_id` varchar(64) DEFAULT NULL COMMENT '订单id',
  `createtime` datetime NOT NULL COMMENT '创建时间',
  `account_id` varchar(64) NOT NULL COMMENT '申请账号id',
  `address` varchar(64) DEFAULT NULL COMMENT '申请时账号绑定的钱包',
  `item_id` int(11) NOT NULL COMMENT '物品id',
  `item_num` int(11) NOT NULL COMMENT '物品数量',
  `id` int(11) NOT NULL COMMENT '商店中的配置id，',
  `goods_num` int(11) NOT NULL COMMENT '购买商品个数',
  `price` varchar(64) DEFAULT NULL COMMENT '价格',
  `ext_data` mediumblob COMMENT '扩展自定义数据',
  `channel` varchar(64) DEFAULT NULL COMMENT 'google or apple',
  `out_order_id` varchar(64) DEFAULT NULL COMMENT 'app store order_id',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `order_id` (`order_id`),
  KEY `out_order_id` (`out_order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8;

CREATE TABLE `t_first_topup` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT,
  `address` varchar(64) NOT NULL COMMENT '账户id',
  `createtime` int(11) NOT NULL COMMENT '首充时间',
  `status1` int(11) NOT NULL DEFAULT '0' COMMENT '领取状态1 0 不能领取 1 可领取状态 2 已领取',
  `status2` int(11) NOT NULL DEFAULT '0' COMMENT '领取状态2',
  `status3` int(11) NOT NULL DEFAULT '0' COMMENT '领取状态3',
  PRIMARY KEY (`idx`,`account_id`),
  UNIQUE KEY `account` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;

insert into version (version) values(2023071001);

commit;