begin;

CREATE TABLE `t_market_store` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` varchar(64) DEFAULT NULL COMMENT '订单id',
  `o_link` varchar(64) DEFAULT NULL COMMENT '关联的链上上架单号',
  `status` int(11) NOT NULL COMMENT '订单状态 0:出售中 1:已下架 2:已售出 3:购买中',
  `owner_address` varchar(60) NOT NULL COMMENT '当前拥有者',
  `token_id` varchar(60) DEFAULT NULL COMMENT 'token_id',
  `nft_token` varchar(64) DEFAULT NULL COMMENT 'nftToken',
  `token_type` int(11) NOT NULL COMMENT 'nft类型 1:英雄 2:枪支 3:芯片',
  `item_id` int(11) DEFAULT NULL COMMENT '特殊字段，用于标记中心化道具，用于交易金币',
  `amount` bigint(20) NOT NULL DEFAULT '1' COMMENT '堆叠数量',
  `createtime` int(11) NOT NULL COMMENT '创建时间(上架时间)',
  `modifytime` int(11) NOT NULL COMMENT '修改时间(更新价格等)',
  `buytime` int(11) NOT NULL COMMENT '开始购买的时间',
  `s_currency` varchar(64) NOT NULL COMMENT '出售时选择的币种地址',
  `s_price` varchar(64) NOT NULL COMMENT '出售价格',
  `c_name` varchar(32) NOT NULL COMMENT '缓存-名称',
  `c_job` int(11) NOT NULL COMMENT '缓存-职业',
  `c_type` int(11) NOT NULL COMMENT '缓存-碎片类型',
  `c_lv` int(11) NOT NULL COMMENT '缓存-级别',
  `c_quality` int(11) NOT NULL COMMENT '缓存-品阶',
  `c_durability` float NOT NULL COMMENT '缓存-能量',
  `c_id` int(11) NOT NULL COMMENT '缓存-id',
  PRIMARY KEY (`idx`) USING BTREE,
  UNIQUE KEY `idx` (`idx`),
  UNIQUE KEY `o_link` (`o_link`) USING BTREE,
  UNIQUE KEY `order_id` (`order_id`) USING BTREE,
  KEY `owner_address` (`owner_address`),
  KEY `token_id` (`token_id`),
  KEY `createtime` (`createtime`),
  KEY `s_currency` (`s_currency`),
  KEY `s_price` (`s_price`),
  KEY `c_name` (`c_name`),
  KEY `c_job` (`c_job`),
  KEY `c_lv` (`c_lv`),
  KEY `c_quality` (`c_quality`),
  KEY `c_durability` (`c_durability`),
  KEY `c_id` (`c_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10048 DEFAULT CHARSET=utf8;

CREATE TABLE `t_market_transaction_record` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT,
  `createtime` int(11) NOT NULL COMMENT '交易成功时间',
  `order_id` varchar(64) NOT NULL DEFAULT '0' COMMENT '订单id',
  `o_link` varchar(64) NOT NULL COMMENT '合约订单id',
  `seller` varchar(60) NOT NULL COMMENT '卖家',
  `buyer` varchar(60) NOT NULL COMMENT '买家',
  `token_id` varchar(60) NOT NULL COMMENT 'tokenid',
  `item_id` int(11) DEFAULT NULL COMMENT '如果有，说明是中心化道具交易',
  `amount` bigint(20) NOT NULL COMMENT '堆叠数量',
  `name` varchar(64) NOT NULL COMMENT '商品名称',
  `type` int(11) NOT NULL COMMENT '商品类型',
  PRIMARY KEY (`idx`),
  KEY `createtime` (`createtime`),
  KEY `seller` (`seller`),
  KEY `buyer` (`buyer`),
  KEY `o_link` (`o_link`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10002 DEFAULT CHARSET=utf8;


ALTER TABLE t_web2_order MODIFY COLUMN `item_num` bigint(20) DEFAULT NULL COMMENT '道具数量';
ALTER TABLE t_web2_order MODIFY COLUMN `goods_num` bigint(20) DEFAULT NULL COMMENT '购买商品个数';
ALTER TABLE t_web2_order CHANGE account_Id account_id varchar(64) NOT NULL COMMENT '申请账号id';
ALTER TABLE t_web2_order MODIFY COLUMN `createtime` int(11) NOT NULL COMMENT '创建时间';

ALTER TABLE t_shop_buy_order ADD COLUMN `order_id` varchar(64) DEFAULT NULL COMMENT '订单id';
ALTER TABLE t_shop_buy_order add UNIQUE KEY `order_id` (`order_id`);

insert into version (version) values(2023071301);

commit;