-- MySQL dump 10.14  Distrib 5.5.41-MariaDB, for Linux (x86_64)
--
-- Host: localhost    Database: accountdb
-- ------------------------------------------------------
-- Server version	5.5.41-MariaDB

--
-- Table structure for table `version`
--

DROP TABLE IF EXISTS `version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `version` (
  `idx` int(11) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `version` int(11) NOT NULL DEFAULT '0' COMMENT '版本号',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `version` (`version`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_user`
--

DROP TABLE IF EXISTS `t_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_user` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `channel` int(11) NOT NULL DEFAULT '0' COMMENT 'channel',
  `address` varchar(60) COMMENT 'address',
  `name` tinyblob COMMENT '用户名字',
  `sex` int(11) NOT NULL DEFAULT '0' COMMENT '性别',
  `head_id` int(11) NOT NULL DEFAULT '0' COMMENT '头像id',
  `head_frame` int(11) NOT NULL DEFAULT '0' COMMENT '头像框id',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT '等级',
  `exp` int(11) NOT NULL DEFAULT '0' COMMENT '经验',
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '段位',
  `history_best_rank` int(11) NOT NULL DEFAULT '0' COMMENT '历史最高段位',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  `history_best_score` int(11) NOT NULL DEFAULT '0' COMMENT '历史最高积分',
  `elo` int(11) NOT NULL DEFAULT '0' COMMENT '隐藏ELO积分',
  `bceg` double NOT NULL DEFAULT '0' COMMENT '中心化代币',
  `gold` double NOT NULL DEFAULT '0' COMMENT '金币',
  `diamond` double NOT NULL DEFAULT '0' COMMENT '钻石',
  `hero_id` bigint NOT NULL DEFAULT '0' COMMENT '当前上阵英雄id',
  `first_fight` int(11) NOT NULL DEFAULT '0' COMMENT '是否首战',
  `last_season_id` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次赛季id',
  `activated` int(11) NOT NULL DEFAULT '0' COMMENT '是否已激活',
  `rename_count` int(11) NOT NULL DEFAULT '0' COMMENT '改名次数',
  `activatetime` int(11) NOT NULL DEFAULT '0' COMMENT '激活时间',
  `already_guide` int(11) NOT NULL DEFAULT '0' COMMENT '已引导',
  `pve_instance_id` int(11) NOT NULL DEFAULT '0' COMMENT '已过pve副本id',
  `like_count` int(11) NOT NULL DEFAULT '0' COMMENT '被点赞次数',
  `head_list` mediumblob COMMENT '拥有的头像列表',
  `head_frame_list` mediumblob COMMENT '拥有的头像框列表',
  `consume_gold` bigint NOT NULL DEFAULT '0' COMMENT '消费金币数',
  `score_modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '积分修改时间',
  `best_rank_modifytime` int(11) NOT NULL DEFAULT '0' COMMENT 'bestrank修改时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  `last_login_time` int(11) NOT NULL DEFAULT '0' COMMENT '上次登录时间',
  `is_gain_item` int(11) NOT NULL DEFAULT '0' COMMENT '是否获取免费item道具',
  `guild_id` varchar(60) NOT NULL DEFAULT '' COMMENT '工会id',
  `guild_job` int(11) NOT NULL DEFAULT '0' COMMENT '工会职位',
  `guild_name` varchar(255) NOT NULL DEFAULT '' COMMENT '工会名称',
  `parachute` int(11) NOT NULL DEFAULT '0' COMMENT '降落伞ID',
  `ring_id` int(11) NOT NULL DEFAULT '0' COMMENT '戒指id',
  `star_num` int(11) NOT NULL DEFAULT '0' COMMENT '星星数(成长任务)',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id` (`account_id`),
  UNIQUE KEY `address` (`address`),
  KEY `channel` (`channel`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bigdata`
--

DROP TABLE IF EXISTS `t_bigdata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bigdata` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'account_id',
  `type` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'type',
  `data` mediumblob COMMENT 'data',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_type` (`account_id`, `type`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;
--

DROP TABLE IF EXISTS `t_user_wallet_offline`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_user_wallet_offline` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `gold` bigint NOT NULL DEFAULT '0' COMMENT '金币',
  `diamond` bigint NOT NULL DEFAULT '0' COMMENT '钻石',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_user_wallet_record`
--

DROP TABLE IF EXISTS `t_user_wallet_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_user_wallet_record` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `txhash` varchar(100) NOT NULL DEFAULT '' COMMENT 'txhash',
  `dir` int(11) NOT NULL DEFAULT '0' COMMENT 'dir',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'type',
  `value` varchar(100) NOT NULL DEFAULT '' COMMENT 'value',
  `state` int(11) NOT NULL DEFAULT '0' COMMENT 'state',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `txhash` (`txhash`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_hero`
--

DROP TABLE IF EXISTS `t_hero`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_hero` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `token_id` varchar(60) COMMENT 'token_id',
  `account_id` varchar(60) COMMENT 'account_id',
  `hero_id` int(11) NOT NULL DEFAULT '0' COMMENT '英雄id',
  `hero_tili` varchar(25) NOT NULL DEFAULT '0' COMMENT '英雄体力',
  `state` int(11) NOT NULL DEFAULT '0' COMMENT '0：已购买 1：体验中',
  `skin_id` int(11) NOT NULL DEFAULT '0' COMMENT '皮肤id',
  `hero_lv` int(11) NOT NULL DEFAULT '0' COMMENT '英雄等级',
  `quality` int(11) NOT NULL DEFAULT '0' COMMENT '品阶',
  `skill_lv1` int(11) NOT NULL DEFAULT '0' COMMENT '必杀技等级',
  `skill_lv2` int(11) NOT NULL DEFAULT '0' COMMENT '躲避技能等级',
  `try_count` int(11) NOT NULL DEFAULT '0' COMMENT '剩余体验次数 当state=1时才有意义',
  `advanced_count` int(11) NOT NULL DEFAULT '0' COMMENT '进阶次数',
  `lock_type` int(11) NOT NULL DEFAULT '0' COMMENT '0:无锁 1:升级 2:升阶 3:悬赏',
  `unlock_time` int(11) NOT NULL DEFAULT '0' COMMENT '解锁时间',
  `unlock_trade_time` int(11) NOT NULL DEFAULT '0' COMMENT '出售解锁时间',
  `rand_attr` mediumblob COMMENT '随机属性',
  `today_get_gold` bigint NOT NULL DEFAULT '0' COMMENT '金币',
  `last_get_gold_time` int(11) NOT NULL DEFAULT '0' COMMENT '最后获取金币的时间',
  `today_pve_get_ceg` bigint NOT NULL DEFAULT '0' COMMENT 'pve金币',
  `last_pve_get_ceg_time` bigint NOT NULL DEFAULT '0' COMMENT '最后pve获取金币的时间',
  `today_mission_get_ceg` bigint NOT NULL DEFAULT '0' COMMENT '悬赏任务获得金币',
  `last_mission_get_ceg_time` bigint NOT NULL DEFAULT '0' COMMENT '最后悬赏任务获取金币的时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  `active_token_id` varchar(60) NOT NULL DEFAULT '' COMMENT 'active_token_id',
  `active_count` int(11) NOT NULL DEFAULT '0' COMMENT 'active_count',
  `activate` int(11) NOT NULL DEFAULT '0' COMMENT '是否激活 1：已初始激活',
  `base_attr` mediumblob COMMENT '初始随机属性（英雄重置时需要）',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `token_id` (`token_id`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_hero_skin`
--

DROP TABLE IF EXISTS `t_hero_skin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_hero_skin` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'account_id',
  `skin_id` int(11) NOT NULL DEFAULT '0' COMMENT '英雄皮肤id',
  `hero_id` int(11) NOT NULL DEFAULT '0' COMMENT '英雄id',
  `skin_state` int(11) NOT NULL DEFAULT '0' COMMENT '英雄皮肤状态 0=已经购，1 = 试用状态',
  `get_from` int(11) NOT NULL DEFAULT '0' COMMENT '获得方式 0 = 系统赠送 1 = 金币购买',
  `consume_num` int(11) NOT NULL DEFAULT '0' COMMENT '消耗货币的具体数量',
  `try_expire_at` int(11) NOT NULL DEFAULT '0' COMMENT '试用截止时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_skinid` (`account_id`, `skin_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bag`
--

DROP TABLE IF EXISTS `t_bag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_bag` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `token_id` varchar(60) COMMENT 'token_id',
  `account_id` varchar(60) COMMENT 'account_id',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '道具id',
  `item_num` int(11) NOT NULL DEFAULT '0' COMMENT '数量',
  `rand_attr` mediumblob COMMENT '随机属性',
  `today_get_gold` bigint NOT NULL DEFAULT '0' COMMENT '金币',
  `last_get_gold_time` int(11) NOT NULL DEFAULT '0' COMMENT '最后获取金币的时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `token_id` (`token_id`),
  KEY `item_id` (`item_id`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bag`
--

--
-- Table structure for table `t_chip`
--

DROP TABLE IF EXISTS `t_chip`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_chip` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `token_id` varchar(60) COMMENT 'token_id',
  `account_id` varchar(60) COMMENT 'account_id',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '道具id',
  `item_num` int(11) NOT NULL DEFAULT '1' COMMENT '数量',
  `chip_grade` int(11) NOT NULL DEFAULT '1' COMMENT '芯片等级',
  `chip_type` int(11) NOT NULL DEFAULT '1' COMMENT '1 攻击；2 防御；3 辅助',
  `state` int(11) NOT NULL DEFAULT '0' COMMENT '0：已购买 1：免费（GIFT标签）',
  `inlay_state` varchar(60) COMMENT '所镶嵌的芯片页id：1|2|3',
  `rand_attr` mediumblob COMMENT '随机属性',
  `active_token_id` varchar(60) NOT NULL DEFAULT '' COMMENT 'active_token_id',
  `active_count` int(11) NOT NULL DEFAULT '0' COMMENT 'active_count',
  `activate` int(11) NOT NULL DEFAULT '0' COMMENT '是否激活 1：已初始激活',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `token_id` (`token_id`),
  KEY `item_id` (`item_id`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_gun`
--

DROP TABLE IF EXISTS `t_gun`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_gun` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `token_id` varchar(60) COMMENT 'token_id',
  `account_id` varchar(60) COMMENT 'account_id',
  `gun_id` int(11) NOT NULL DEFAULT '0' COMMENT '枪id',
  `state` int(11) NOT NULL DEFAULT '0' COMMENT '0：已购买 1：体验中',
  `gun_lv` int(11) NOT NULL DEFAULT '0' COMMENT '枪等级',
  `quality` int(11) NOT NULL DEFAULT '0' COMMENT '品阶',
  `try_count` int(11) NOT NULL DEFAULT '0' COMMENT '剩余体验次数 当state=1时才有意义',
  `lock_type` int(11) NOT NULL DEFAULT '0' COMMENT '0:无锁 1:升级 2:升阶 3:悬赏',
  `unlock_time` int(11) NOT NULL DEFAULT '0' COMMENT '解锁时间',
  `unlock_trade_time` int(11) NOT NULL DEFAULT '0' COMMENT '出售解锁时间',
  `durability` varchar(25) NOT NULL DEFAULT '0' COMMENT '耐久',
  `rand_attr` mediumblob COMMENT '随机属性',
  `today_get_gold` bigint NOT NULL DEFAULT '0' COMMENT '金币',
  `last_get_gold_time` int(11) NOT NULL DEFAULT '0' COMMENT '最后获取金币的时间',
  `today_pve_get_ceg` bigint NOT NULL DEFAULT '0' COMMENT 'pve金币',
  `last_pve_get_ceg_time` bigint NOT NULL DEFAULT '0' COMMENT '最后pve获取金币的时间',
  `today_mission_get_ceg` bigint NOT NULL DEFAULT '0' COMMENT '悬赏任务获得金币',
  `last_mission_get_ceg_time` bigint NOT NULL DEFAULT '0' COMMENT '最后悬赏任务获取金币的时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  `active_token_id` varchar(60) NOT NULL DEFAULT '' COMMENT 'active_token_id',
  `active_count` int(11) NOT NULL DEFAULT '0' COMMENT 'active_count',
  `activate` int(11) NOT NULL DEFAULT '0' COMMENT '是否激活 1：已初始激活',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `token_id` (`token_id`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_gun_skin`
--

DROP TABLE IF EXISTS `t_gun_skin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_gun_skin` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'account_id',
  `skin_id` int(11) NOT NULL DEFAULT '0' COMMENT '皮肤ID',
  `skin_state` int(11) NOT NULL DEFAULT '0' COMMENT '状态（0=已经购，1 = 试用状态）',
  `try_expire_at` int(11) NOT NULL DEFAULT '0' COMMENT '试用截止时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_skin_id` (`account_id`, `skin_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_gun_talent`
--

DROP TABLE IF EXISTS `t_gun_talent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_gun_talent` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'account_id',
  `talent_id` int(11) NOT NULL DEFAULT '0' COMMENT '技能ID',
  `talent_lv` int(11) NOT NULL DEFAULT '0' COMMENT '技能等级',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_talent_id` (`account_id`, `talent_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_dyndata`
--

DROP TABLE IF EXISTS `t_dyndata`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_dyndata` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `x` int(11) NOT NULL DEFAULT '0' COMMENT 'x',
  `y` int(11) NOT NULL DEFAULT '0' COMMENT 'y',
  `val` bigint NOT NULL DEFAULT '0' COMMENT 'val',
  `createtime`   int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime`   int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_x_y` (`account_id`, `x`, `y`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_shop_buy_record`
--

DROP TABLE IF EXISTS `t_shop_buy_record`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_shop_buy_record` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '道具id',
  `this_day_buy_times` int(11) NOT NULL DEFAULT '0' COMMENT '今日购买次数',
  `this_week_buy_times` int(11) NOT NULL DEFAULT '0' COMMENT '本周购买次数',
  `total_buy_times` int(11) NOT NULL DEFAULT '0' COMMENT '总购买次数',
  `last_buy_time` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次购买时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`),
  UNIQUE KEY `account_id_item_id` (`account_id`, `item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_mission`
--

DROP TABLE IF EXISTS `t_mission`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_mission` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `mission_id` int(11) NOT NULL DEFAULT '0' COMMENT '任务id',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`),
  UNIQUE KEY `account_id_mission_id` (`account_id`, `mission_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_battle`
--

DROP TABLE IF EXISTS `t_battle`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_battle` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `battle_data` mediumblob COMMENT 'battle_data',
  `kills_modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '击杀修改时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_battle_record`
--

DROP TABLE IF EXISTS `t_battle_record`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_battle_record` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `request` mediumblob COMMENT 'request',
  `kills_modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '击杀修改时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_season`
--

DROP TABLE IF EXISTS `t_season`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_season` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `season_id` int(11) NOT NULL DEFAULT '0' COMMENT '赛季id',
  `card_lv` int(11) NOT NULL DEFAULT '0' COMMENT '赛季手册等级',
  `card_exp` int(11) NOT NULL DEFAULT '0' COMMENT '赛季手册经验',
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '段位',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  `elo` int(11) NOT NULL DEFAULT '0' COMMENT '隐藏ELO积分',
  `history_best_rank` int(11) NOT NULL DEFAULT '0' COMMENT '历史最高段位',
  `gift_state1` int(11) NOT NULL DEFAULT '0' COMMENT '普通礼包购买状态 0:未购 1:已购',
  `gift_buytime1` int(11) NOT NULL DEFAULT '0' COMMENT '普通礼包购买时间',
  `gift_state2` int(11) NOT NULL DEFAULT '0' COMMENT '豪华礼包购买状态 0:未购 1:已购',
  `gift_buytime2` int(11) NOT NULL DEFAULT '0' COMMENT '豪华礼包购买时间',
  `battle_data` mediumblob COMMENT 'battle_data',
  `kills_modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '击杀修改时间',
  `score_modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '积分修改时间',
  `best_rank_modifytime` int(11) NOT NULL DEFAULT '0' COMMENT 'bestrank修改时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`),
  UNIQUE KEY `account_id_season_id` (`account_id`, `season_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_season_card`
--

DROP TABLE IF EXISTS `t_season_card`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_season_card` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `season_id` int(11) NOT NULL DEFAULT '0' COMMENT '赛季id',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '手册类型 1：普通 2：精英',
  `card_lv` int(11) NOT NULL DEFAULT '0' COMMENT '赛季手册等级',
  `reward_received` int(11) NOT NULL DEFAULT '0' COMMENT '赛季手册等级奖励是否已领取',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id_season_id` (`account_id`, `season_id`),
  UNIQUE KEY `account_id_season_id_type_card_lv` (`account_id`, `season_id`, `type`, `card_lv`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_used_name`
--

DROP TABLE IF EXISTS `t_used_name`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_used_name` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` tinyblob COMMENT '名字',
  `name_base64` varchar(255) NOT NULL DEFAULT '' COMMENT '名字base64',
  `key` varchar(60) NOT NULL DEFAULT '' COMMENT '应用key',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `name_base64_key` (`name_base64`, `key`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_drop_log`
--

DROP TABLE IF EXISTS `t_drop_log`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_drop_log` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `drop_source` varchar(60) NOT NULL DEFAULT '' COMMENT '掉落源',
  `drop_id` varchar(60) NOT NULL DEFAULT '' COMMENT '掉落id',
  `drop_items` mediumblob COMMENT '掉落的物品',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id_drop_source_drop_id` (`account_id`, `drop_source`, `drop_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_rank_activity`
--

DROP TABLE IF EXISTS `t_rank_activity`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_rank_activity` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `channel` int(11) NOT NULL DEFAULT '0' COMMENT 'channel',
  `guild_id` varchar(60) NOT NULL DEFAULT '' COMMENT '工会id',
  `wave` int(11) NOT NULL DEFAULT '0' COMMENT 'wave',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'type',
  `value` double NOT NULL DEFAULT '0' COMMENT 'value',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_wave_type` (`account_id`, `wave`, `type`),
  KEY `channel` (`channel`),
  KEY `type` (`type`),
  KEY `guild_id` (`guild_id`),
  KEY `value` (`value`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_game_log`
--

DROP TABLE IF EXISTS `t_game_log`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_game_log` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `type` varchar(255) NOT NULL DEFAULT '' COMMENT '日志类型',
  `subtype` varchar(255) NOT NULL DEFAULT '' COMMENT '日志子类型',
  `param1` varchar(666) NOT NULL DEFAULT '' COMMENT 'param1',
  `param2` varchar(666) NOT NULL DEFAULT '' COMMENT 'param2',
  `param3` varchar(666) NOT NULL DEFAULT '' COMMENT 'param3',
  `param4` varchar(666) NOT NULL DEFAULT '' COMMENT 'param4',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id_type_subtype` (`account_id`, `type`, `subtype`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

-- Dump completed on 2015-08-19 18:51:22

--
-- Table structure for table `t_nft_active`
--

DROP TABLE IF EXISTS `t_nft_active`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_nft_active` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `uniid` varchar(255) NOT NULL DEFAULT '' COMMENT 'nft uniid',
  `token_id` varchar(255) NOT NULL DEFAULT '' COMMENT 'token id',
  `daytime` int(11) NOT NULL DEFAULT '0' COMMENT '今天0点时间',
  `token_type` int(11) NOT NULL DEFAULT '0' COMMENT 'nft类型 1:英雄 2:枪支 3:芯片 5:碎片箱子',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `uniid_daytime_type` (`uniid`, `daytime`,`token_type`),
  KEY `account_id_token_type` (`account_id`,`token_type`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_fragment_pool`
--

DROP TABLE IF EXISTS `t_fragment_pool`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_fragment_pool` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `fragment_id` int(11) NOT NULL DEFAULT '0' COMMENT '碎片id',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '0:pvp 1:pve',
  `fragment_type` int(11) NOT NULL DEFAULT '0' COMMENT '碎片类型 0:英雄 1:武器',
  `fragment_num` int(11) NOT NULL DEFAULT '0' COMMENT '剩余碎片数量',
  `alloced_num` int(11) NOT NULL DEFAULT '0' COMMENT '已经分配的碎片数量',
  `alloc_num` int(11) NOT NULL DEFAULT '0' COMMENT '分配的碎片数量',
  `alloc_time` int(11) NOT NULL DEFAULT '0' COMMENT '分配时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `alloc_time_type_fragment_type` (`alloc_time`, `type`, `fragment_type`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_fragment_record`
--

DROP TABLE IF EXISTS `t_fragment_record`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_fragment_record` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `param` int(11) NOT NULL DEFAULT '0' COMMENT 'param',
  `value` int(11) NOT NULL DEFAULT '0' COMMENT '有效场次',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_param` (`account_id`, `param`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_realtime_data`
--

DROP TABLE IF EXISTS `t_realtime_data`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_realtime_data` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `name` varchar(60) NOT NULL DEFAULT '' COMMENT '参数名',
  `value1` varchar(60) NOT NULL DEFAULT '' COMMENT '值1',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_battle_settlement_single`
--

DROP TABLE IF EXISTS `t_battle_settlement_single`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_battle_settlement_single` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `battle_uuid` varchar(60) NOT NULL DEFAULT '' COMMENT '战斗记录唯一id',
  `account_id` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'account_id',
  `room_uuid` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'room_uuid',
  `data` mediumblob COMMENT 'data',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_battle_uniid` (`account_id`, `battle_uuid`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_battle_settlement_team`
--

DROP TABLE IF EXISTS `t_battle_settlement_team`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_battle_settlement_team` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `battle_uuid` varchar(60) NOT NULL DEFAULT '' COMMENT '战斗记录唯一id',
  `room_uuid` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'room_id',
  `data` mediumblob COMMENT 'data',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `battle_room_uuid` (`battle_uuid`, `room_uuid`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_battle_settlement_team`
--

DROP TABLE IF EXISTS `t_battle_input`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_battle_input` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `battle_uuid` varchar(60) NOT NULL DEFAULT '' COMMENT '战斗记录唯一id',
  `room_uuid` varchar(60) CHARACTER SET utf8 NOT NULL COMMENT 'room_id',
  `input` mediumblob COMMENT 'input',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `battle_room_uuid` (`battle_uuid`, `room_uuid`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_battle_history`
--

DROP TABLE IF EXISTS `t_battle_history`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_battle_history` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `battle_uniid` varchar(60) NOT NULL DEFAULT '' COMMENT '战斗记录唯一id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '用户 account_id',
  `match_mode` int(11) NOT NULL DEFAULT '0' COMMENT '0: 匹配 pvp 1: 排位赛 2: pve',
  `team_mode` int(11) NOT NULL DEFAULT '0' COMMENT '队伍模式 0:单人 1：组队',
  `battle_rank` int(11) NOT NULL DEFAULT '0' COMMENT '战斗排名',
  `team_rank` int(11) NOT NULL DEFAULT '0' COMMENT '团队排名',
  `team_kills` int(11) NOT NULL DEFAULT '0' COMMENT '团队击杀数',
  `gold` int(11) NOT NULL DEFAULT '0' COMMENT 'gold获得数',
  `is_win` int(11) NOT NULL DEFAULT '0' COMMENT 'pve冒险是否胜利',
  `kills` int(11) NOT NULL DEFAULT '0' COMMENT '击杀数',
  `hero_id` int(11) NOT NULL DEFAULT '0' COMMENT '英雄 id',
  `weapon1` int(11) NOT NULL DEFAULT '0' COMMENT '枪械1 id',
  `weapon2` int(11) NOT NULL DEFAULT '0' COMMENT '枪械2 id',
  `damage` int(11) NOT NULL DEFAULT '0' COMMENT '伤害',
  `battle_end_time` int(11) NOT NULL DEFAULT '0' COMMENT '战斗结束时间',
  `current_level_class` varchar(60) NOT NULL DEFAULT '0' COMMENT '当前用户段位',
  `current_level_class_score` int(11) NOT NULL DEFAULT '0' COMMENT '当前用户排位分',
  `level_class_score_chg` int(11) NOT NULL DEFAULT '0' COMMENT '排位分改变',
  `pve_rank_score` int(11) NOT NULL DEFAULT '0' COMMENT 'pve冒险积分',
  `pve_kill_boss` int(11) NOT NULL DEFAULT '0' COMMENT 'pve冒险是否击杀BOSS',
  `pve_instance_id` int(11) NOT NULL DEFAULT '0' COMMENT 'pve副本难度id',
  `pve_instance_mode` int(11) NOT NULL DEFAULT '0' COMMENT 'pve副本mode',
  `battle_foreign_key` int(11) NOT NULL DEFAULT '0' COMMENT '结算外键',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_battle_uniid` (`account_id`, `battle_uniid`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_guide_data`
--

DROP TABLE IF EXISTS `t_guide_data`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_guide_data` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `data` varchar(255) NOT NULL DEFAULT '' COMMENT '值1',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

-- Dump completed on 2015-08-19 18:51:22

--
-- Table structure for table `t_user_season_ring`
--

DROP TABLE IF EXISTS `t_user_season_ring`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_user_season_ring` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '道具id',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_season_ranking`
--

DROP TABLE IF EXISTS `t_season_ranking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_season_ranking` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `address` varchar(60) COMMENT 'address',
  `channel` int(11) NOT NULL DEFAULT '0' COMMENT 'channel',
  `rank` int(11) NOT NULL DEFAULT '0' COMMENT '段位',
  `score` int(11) NOT NULL DEFAULT '0' COMMENT '积分',
  `ranking` int(11) NOT NULL DEFAULT '0' COMMENT '排名',
  `ranking_point` bigint NOT NULL DEFAULT '0' COMMENT '排名SV积分',
  `season` int(11) NOT NULL DEFAULT '0' COMMENT '赛季',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_season` (`account_id`, `season`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_parachute`
--

DROP TABLE IF EXISTS `t_parachute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_parachute` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '道具id',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_transaction`
--

DROP TABLE IF EXISTS `t_transaction`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_transaction` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `address` varchar(60) NOT NULL DEFAULT '' COMMENT 'address',
  `trans_id` varchar(255) NOT NULL DEFAULT '' COMMENT '事务id',
  `action` int(11) NOT NULL DEFAULT '0' COMMENT 'action',
  `token_id` varchar(60) NOT NULL DEFAULT '' COMMENT 'token_id',
  `token_type` int(11) NOT NULL DEFAULT '0' COMMENT 'token_type',
  `item_uniid` bigint NOT NULL DEFAULT '0' COMMENT '道具uniid',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '道具id',
  `item_num` bigint NOT NULL DEFAULT '0' COMMENT '道具num',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'status',
  `result` int(11) NOT NULL DEFAULT '0' COMMENT 'result 0：失败 1：成功',
  `client_confirmed` int(11) NOT NULL DEFAULT '0' COMMENT 'client_confirmed',
  `client_result` mediumblob COMMENT 'client_result',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `trans_id` (`trans_id`),
  KEY `account_id` (`account_id`),
  KEY `address` (`address`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_transaction_prefee`
--

DROP TABLE IF EXISTS `t_transaction_prefee`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_transaction_prefee` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `trans_id` varchar(255) NOT NULL DEFAULT '' COMMENT '事务id',
  `target_token_id` bigint NOT NULL DEFAULT '0' COMMENT 'target_token_id',
  `target_token_type` bigint NOT NULL DEFAULT '0' COMMENT 'target_token_type',
  `item_uniid` bigint NOT NULL DEFAULT '0' COMMENT '道具uniid',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '道具id',
  `item_num` double NOT NULL DEFAULT '0' COMMENT '道具数量',
  `done` int(11) NOT NULL DEFAULT '0' COMMENT 'done',
  `state` int(11) NOT NULL DEFAULT '0' COMMENT 'state',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `trans_id` (`trans_id`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_nft_up_event`
--

DROP TABLE IF EXISTS `t_nft_up_event`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_nft_up_event` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `trans_id` varchar(255) NOT NULL DEFAULT '' COMMENT '事务id',
  `token_id` varchar(60) NOT NULL DEFAULT '' COMMENT 'token_id',
  `value`  int(11) NOT NULL DEFAULT '0' COMMENT 'value',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `trans_id` (`trans_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

DROP TABLE IF EXISTS `t_nft_up_receive`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_nft_up_receive` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `trans_id` varchar(255) NOT NULL DEFAULT '' COMMENT '事务id',
  `token_id1` varchar(60) NOT NULL DEFAULT '' COMMENT 'token_id1',
  `token_id2` varchar(60) NOT NULL DEFAULT '' COMMENT 'token_id2',
  `state`  int(11) NOT NULL DEFAULT '0' COMMENT '0进阶中,1可领取',
  `token_type`  int(11) NOT NULL DEFAULT '0' COMMENT '1英雄,2枪械',
  `from_data`  int(11) NOT NULL DEFAULT '0' COMMENT '0本地,1链',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `trans_id` (`trans_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_event_ranking`
--

DROP TABLE IF EXISTS `t_event_ranking`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_event_ranking` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `wave` int(11) NOT NULL DEFAULT '0' COMMENT 'wave',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'type',
  `value` double NOT NULL DEFAULT '0' COMMENT 'value',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_wave_type` (`account_id`, `wave`, `type`),
  KEY `value` (`value`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_user_currency`
--

DROP TABLE IF EXISTS `t_user_currency`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_user_currency` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `net_id` int(11) NOT NULL DEFAULT '0' COMMENT '链id',
  `address` varchar(60) NOT NULL DEFAULT '' COMMENT '货币地址',
  `symbol` varchar(10) NOT NULL DEFAULT '' COMMENT '符号',
  `precision` int(11) NOT NULL DEFAULT '0' COMMENT '精度',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT '类型 1:ERC721 2:ERC1155 3:ERC20',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_net_address` (`account_id`, `net_id`, `address`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_emoji`
--

DROP TABLE IF EXISTS `t_emoji`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_emoji` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT 'itemID',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_item_id` (`account_id`, `item_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_user_use_emoji`
--

DROP TABLE IF EXISTS `t_user_use_emoji`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_user_use_emoji` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `value` varchar(255) NOT NULL DEFAULT '' COMMENT '选中表情itemID',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_chip_page`
--

DROP TABLE IF EXISTS `t_chip_page`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_chip_page` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `page_name` varchar(50) NOT NULL DEFAULT '' COMMENT '页名',
  `page_id` int(11) NOT NULL DEFAULT '0' COMMENT '页id',
  `data` mediumblob COMMENT 'data',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_page_id` (`account_id`, `page_id`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_hero_preset`
--

DROP TABLE IF EXISTS `t_hero_preset`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_hero_preset` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `hero_uid` bigint NOT NULL DEFAULT 0 COMMENT 'hero uniid',
  `skill_id` int(11) NOT NULL DEFAULT 0 COMMENT '技能 item_id',
  `weapon_uid1` bigint NOT NULL DEFAULT 0 COMMENT 'gun uniid1',
  `weapon_uid2` bigint NOT NULL DEFAULT 0 COMMENT 'gun uniid2',
  `chip_page` int(11) NOT NULL DEFAULT 0 COMMENT '芯片页id',
  `createtime` int(11) NOT NULL DEFAULT 0 COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT 0 COMMENT '修改时间',
  PRIMARY KEY (`idx`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_rank_battle`
--

DROP TABLE IF EXISTS `t_rank_battle`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_rank_battle` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `channel` int(11) NOT NULL DEFAULT '0' COMMENT 'channel',
  `type` int(11) NOT NULL DEFAULT '0' COMMENT 'type 1:场次榜 2:吃鸡榜 3:mvp榜 4:前三名榜 5:击杀榜',
  `value` bigint NOT NULL DEFAULT '0' COMMENT 'value',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id_type` (`account_id`, `type`),
  KEY `channel` (`channel`),
  KEY `type` (`type`),
  KEY `value` (`value`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_mission_star`
--

DROP TABLE IF EXISTS `t_mission_star`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_mission_star` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `season_id` int(11) NOT NULL DEFAULT '0' COMMENT '成长任务赛季id',
  `mission_id` int(11) NOT NULL DEFAULT '0' COMMENT '成长任务id',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_season_mission_id` (`account_id`, `season_id`, `mission_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_user_sign_log`
--

DROP TABLE IF EXISTS `t_user_sign_log`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_user_sign_log` (
  `idx` int(10) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `days` int(10) DEFAULT '0' COMMENT '累计签到天数',
  `sign_time` int(10) DEFAULT NULL COMMENT '签到时间',
  `is_receive` tinyint(4) DEFAULT '0' COMMENT '是否领取奖励',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_first_topup`
--

DROP TABLE IF EXISTS `t_first_topup`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_first_topup` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT,
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `address` varchar(60) COMMENT 'address',
  `status1` int(11) NOT NULL DEFAULT '0' COMMENT '领取状态1 0 不能领取 1 可领取状态 2 已领取',
  `status2` int(11) NOT NULL DEFAULT '0' COMMENT '领取状态2',
  `status3` int(11) NOT NULL DEFAULT '0' COMMENT '领取状态3',
  `createtime` int(11) NOT NULL COMMENT '首充时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_shop_buy_order`
--

DROP TABLE IF EXISTS `t_shop_buy_order`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_shop_buy_order` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '订单id',
  `order_id` varchar(64) DEFAULT NULL COMMENT '订单id',
  `address` varchar(60) NOT NULL COMMENT '账户地址',
  `createtime` int(11) NOT NULL COMMENT '订单开始时间',
  `id` int(11) NOT NULL COMMENT '商店货物id',
  `item_id` int(11) NOT NULL COMMENT '道具id',
  `goods_num` bigint(20) NOT NULL COMMENT '购买个数',
  `status` int(11) NOT NULL COMMENT '订单状态 0-客户端申请了订单 1-订单完成 2-订单失败',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `order_id` (`order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=184 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_user_pass`
--

DROP TABLE IF EXISTS `t_user_pass`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_user_pass` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL COMMENT '账户id',
  `season_id` int(11) NOT NULL DEFAULT '0' COMMENT '通行证赛季',
  `data` mediumblob COMMENT 'data',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `account_season_id` (`account_id`, `season_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_bc_order`
--

DROP TABLE IF EXISTS `t_bc_order`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_bc_order` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` varchar(255) COMMENT '订单号',
  `order_type` int(11) NOT NULL COMMENT '0:默认',
  `account_id` varchar(60) NOT NULL COMMENT '账户id 只用做事后分析用',
  `address` varchar(60) COMMENT 'address',
  `currency_name` varchar(60) NOT NULL DEFAULT '' COMMENT 'currency_name',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT '0: 支付中 1： 已发货',
  `item_id` int(11) NOT NULL COMMENT '道具id',
  `item_num` bigint NOT NULL DEFAULT '0' COMMENT '道具数量',
  `ext_data` mediumblob COMMENT '扩展数据自定义',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  `price` varchar(60) COLLATE utf8_bin NOT NULL COMMENT '价格',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `order_id` (`order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_shop_dailyselection`
--

DROP TABLE IF EXISTS `t_shop_dailyselection`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_shop_dailyselection` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `address` varchar(60) NOT NULL COMMENT 'address',
  `refresh_mode` int(11) NOT NULL COMMENT '0-每日自动刷新时间 1-手动刷新时间',
  `refresh_time` int(11) NOT NULL DEFAULT '0' COMMENT '刷新时间',
  `grid_1` int(11) NOT NULL,
  `grid_2` int(11) NOT NULL,
  `grid_3` int(11) NOT NULL,
  `grid_4` int(11) NOT NULL,
  `grid_5` int(11) NOT NULL,
  `grid_6` int(11) NOT NULL,
  `count_1` tinyint(4) NOT NULL,
  `count_2` tinyint(4) NOT NULL,
  `count_3` tinyint(4) NOT NULL,
  `count_4` tinyint(4) NOT NULL,
  `count_5` tinyint(4) NOT NULL,
  `count_6` tinyint(4) NOT NULL,
  PRIMARY KEY (`idx`),
  KEY `refresh_time` (`refresh_time`),
  KEY `address` (`address`),
  KEY `refresh_mode` (`refresh_mode`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

DROP TABLE IF EXISTS `t_shop_free_record`;
CREATE TABLE `t_shop_free_record` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL COMMENT '账号id',
  `shop_id` int(11) NOT NULL COMMENT '商店id',
  `id` int(11) NOT NULL COMMENT '货架id',
  `goods_id` int(11) NOT NULL COMMENT '道具id',
  `goods_num` int(11) NOT NULL COMMENT '道具数量',
  `free_type` int(11) NOT NULL COMMENT '免费类型',
  `free_num` int(11) NOT NULL COMMENT '免费数量',
  `createtime` int(11) NOT NULL COMMENT '创建时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`),
  KEY `createtime` (`createtime`),
  KEY `id` (`id`),
  KEY `goods_id` (`goods_id`)
) ENGINE=InnoDB AUTO_INCREMENT=78 DEFAULT CHARSET=utf8;


--
-- Table structure for table `t_user_honor`
--

DROP TABLE IF EXISTS `t_user_honor`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_user_honor` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `address` varchar(60) NOT NULL COMMENT '钱包地址',
  `honor1` int(11)  NOT NULL DEFAULT '0' COMMENT 'nft类型6 1:佩戴',
  `honor2` int(11)  NOT NULL DEFAULT '0' COMMENT 'honor2',
  `honor3` int(11)  NOT NULL DEFAULT '0' COMMENT 'honor3',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `address` (`address`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_orderid`
--

DROP TABLE IF EXISTS `t_orderid`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_orderid` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `request` mediumblob COMMENT 'request',
  `confirmed` int(11) NOT NULL DEFAULT '0' COMMENT '是否已确认',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_inapp_record`
--

DROP TABLE IF EXISTS `t_inapp_record`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_inapp_record` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `amount` double NOT NULL DEFAULT '0' COMMENT '充值总额',
  `buy_times` int(11) NOT NULL DEFAULT '0' COMMENT '充值次数',
  `amount_ok` double NOT NULL DEFAULT '0' COMMENT '充值成功总额',
  `buy_ok_times` int(11) NOT NULL DEFAULT '0' COMMENT '充值成功次数',
  `daytime` int(11) NOT NULL DEFAULT '0' COMMENT '时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_inapp_order`
--

DROP TABLE IF EXISTS `t_inapp_order`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_inapp_order` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` varchar(60) NOT NULL DEFAULT '' COMMENT '订单id',
  `sp_order_id` varchar(64) DEFAULT NULL COMMENT 'app store order_id',
  `platform` int(11) NOT NULL DEFAULT '0' COMMENT '0: ios 1: android',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '申请账号id',
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '物品id',
  `price` double NOT NULL DEFAULT '0' COMMENT '价格',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'status',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `order_id` (`order_id`),
  UNIQUE KEY `platform_sp_order_id` (`platform`, `sp_order_id`),
  KEY `account_id` (`account_id`),
  KEY `sp_order_id` (`sp_order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_outapp_order`
--

DROP TABLE IF EXISTS `t_outapp_order`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_outapp_order` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` varchar(60) NOT NULL DEFAULT '' COMMENT '订单id',
  `sp_order_id` varchar(64) DEFAULT NULL COMMENT 'app store order_id',
  `platform` int(11) NOT NULL DEFAULT '0' COMMENT '0: ios 1: android',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '申请账号id',
  `address` varchar(60) DEFAULT NULL COMMENT '申请时账号绑定的钱包',
  `goods_id` int(11) NOT NULL DEFAULT '0' COMMENT '物品id',
  `price` double NOT NULL DEFAULT '0' COMMENT '价格',
  `params` mediumblob COMMENT 'params',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'status',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `order_id` (`order_id`),
  UNIQUE KEY `platform_sp_order_id` (`platform`, `sp_order_id`),
  KEY `account_id` (`account_id`),
  KEY `address` (`address`),
  KEY `sp_order_id` (`sp_order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_mall`
--

DROP TABLE IF EXISTS `t_mall`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_mall` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` varchar(255) NOT NULL DEFAULT '' COMMENT '订单id',
  `goods_uuid` varchar(255) NOT NULL DEFAULT '' COMMENT '商品uuid',
  `seller` varchar(60) NOT NULL DEFAULT '' COMMENT 'seller',
  `seller_address` varchar(60) NOT NULL DEFAULT '' COMMENT 'seller_address',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '物品id',
  `item_num` bigint NOT NULL DEFAULT '0' COMMENT '物品数量',
  `currency` varchar(60) NOT NULL COMMENT 'currency',
  `price` varchar(255) NOT NULL DEFAULT '' COMMENT 'price',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'status',
  `last_buy_time` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次购买时间',
  `last_buyer` varchar(60) NOT NULL DEFAULT '' COMMENT '最后一次购买者',
  `last_modify_price_time` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次修改价格事件',
  `buyer` varchar(60) NOT NULL DEFAULT '' COMMENT '购买成功者',
  `buy_ok_time` int(11) NOT NULL DEFAULT '0' COMMENT '购买成功时间',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `seller` (`seller`),
  KEY `seller_address` (`seller_address`),
  KEY `price` (`price`),
  UNIQUE KEY `order_id` (`order_id`),
  UNIQUE KEY `goods_uuid` (`goods_uuid`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_market`
--

DROP TABLE IF EXISTS `t_market`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_market` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `net_id` bigint NOT NULL DEFAULT '0' COMMENT 'net_id',
  `order_id` varchar(255) NOT NULL DEFAULT '' COMMENT '订单id',
  `token_id` varchar(60) NOT NULL COMMENT 'token_id',
  `seller` varchar(60) NOT NULL COMMENT 'owner',
  `buyer` varchar(60) NOT NULL COMMENT 'owner',
  `nft_token` varchar(60) NOT NULL COMMENT 'nft_token',
  `amount` varchar(255) NOT NULL DEFAULT '' COMMENT 'amount',
  `currency` varchar(60) NOT NULL COMMENT 'currency',
  `price` varchar(255) NOT NULL DEFAULT '' COMMENT 'price',
  `update_price` varchar(255) COMMENT 'update_price',
  `update_time` int(11) COMMENT 'update_time',
  `c_name` varchar(32) NOT NULL DEFAULT '' COMMENT '缓存-名称',
  `c_job` int(11) NOT NULL DEFAULT '0' COMMENT '缓存-职业',
  `c_type` int(11) NOT NULL DEFAULT '0' COMMENT '缓存-碎片类型',
  `c_lv` int(11) NOT NULL DEFAULT '0' COMMENT '缓存-级别',
  `c_quality` int(11) NOT NULL DEFAULT '0' COMMENT '缓存-品阶',
  `c_durability` float NOT NULL DEFAULT '0' COMMENT '缓存-能量',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'status',
  `activated` int(11) NOT NULL DEFAULT '0' COMMENT 'activated',
  `selltime` int(11) COMMENT 'selltime',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `order_id` (`order_id`),
  KEY `seller_activated` (`seller`, `activated`),
  KEY `activated` (`activated`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;

DROP TABLE IF EXISTS `t_web2_order`;
CREATE TABLE `t_web2_order` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `status` int(11) NOT NULL COMMENT '订单状态 0-客户端申请了订单 1-订单完成 2-订单失败',
  `order_id` varchar(64) DEFAULT NULL COMMENT '订单id',
  `createtime` datetime NOT NULL COMMENT '创建时间',
  `account_id` varchar(64) NOT NULL COMMENT '申请账号id',
  `address` varchar(64) DEFAULT NULL COMMENT '申请时账号绑定的钱包',
  `item_id` int(11) NOT NULL COMMENT '物品id',
  `item_num` bigint(20) NOT NULL COMMENT '物品数量',
  `id` int(11) NOT NULL COMMENT '商店中的配置id，',
  `goods_num` bigint(20) NOT NULL COMMENT '购买商品个数',
  `price` varchar(64) DEFAULT NULL COMMENT '价格',
  `ext_data` mediumblob COMMENT '扩展自定义数据',
  `channel` varchar(64) DEFAULT NULL COMMENT 'google or apple',
  `out_order_id` varchar(64) DEFAULT NULL COMMENT 'app store order_id',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `order_id` (`order_id`),
  KEY `out_order_id` (`out_order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_market_store`;
CREATE TABLE `t_market_store` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `order_id` varchar(64) DEFAULT NULL COMMENT '订单id',
  `o_link` varchar(64) DEFAULT NULL COMMENT '关联的链上上架单号',
  `status` int(11) NOT NULL COMMENT '订单状态 0:出售中 1:已下架 2:已售出 3:购买中',
  `owner_address` varchar(60) NOT NULL COMMENT '当前拥有者',
  `token_id` varchar(60) DEFAULT NULL COMMENT 'token_id',
  `nft_token` varchar(64) DEFAULT NULL COMMENT 'nftToken',
  `token_type` int(11) NOT NULL COMMENT 'nft类型 1:英雄 2:枪支 3:芯片',
  `item_id` int(11) DEFAULT NULL COMMENT '特殊字段，用于标记中心化道具，用于交易金币',
  `amount` bigint(20) NOT NULL DEFAULT '1' COMMENT '堆叠数量',
  `createtime` int(11) NOT NULL COMMENT '创建时间(上架时间)',
  `modifytime` int(11) NOT NULL COMMENT '修改时间(更新价格等)',
  `buytime` int(11) DEFAULT NULL COMMENT '开始购买的时间',
  `s_currency` varchar(64) DEFAULT NULL COMMENT '出售时选择的币种地址',
  `s_price` varchar(64) NOT NULL COMMENT '出售价格',
  `c_name` varchar(32) NOT NULL COMMENT '缓存-名称',
  `c_job` int(11) NOT NULL COMMENT '缓存-职业',
  `c_type` int(11) NOT NULL COMMENT '缓存-碎片类型',
  `c_lv` int(11) NOT NULL COMMENT '缓存-级别',
  `c_quality` int(11) NOT NULL COMMENT '缓存-品阶',
  `c_durability` float NOT NULL COMMENT '缓存-能量',
  `c_id` int(11) NOT NULL COMMENT '缓存-id',
  PRIMARY KEY (`idx`) USING BTREE,
  UNIQUE KEY `idx` (`idx`),
  UNIQUE KEY `o_link` (`o_link`) USING BTREE,
  UNIQUE KEY `order_id` (`order_id`) USING BTREE,
  KEY `owner_address` (`owner_address`),
  KEY `token_id` (`token_id`),
  KEY `createtime` (`createtime`),
  KEY `s_currency` (`s_currency`),
  KEY `s_price` (`s_price`),
  KEY `c_name` (`c_name`),
  KEY `c_job` (`c_job`),
  KEY `c_lv` (`c_lv`),
  KEY `c_quality` (`c_quality`),
  KEY `c_durability` (`c_durability`),
  KEY `c_id` (`c_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10048 DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `t_market_transaction_record`;
CREATE TABLE `t_market_transaction_record` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT,
  `createtime` int(11) NOT NULL COMMENT '交易成功时间',
  `order_id` varchar(64) NOT NULL DEFAULT '0' COMMENT '订单id',
  `o_link` varchar(64) NOT NULL COMMENT '合约订单id',
  `seller` varchar(60) NOT NULL COMMENT '卖家',
  `buyer` varchar(60) NOT NULL COMMENT '买家',
  `token_id` varchar(60) NOT NULL COMMENT 'tokenid',
  `item_id` int(11) DEFAULT NULL COMMENT '如果有，说明是中心化道具交易',
  `amount` bigint(20) NOT NULL COMMENT '堆叠数量',
  `name` varchar(64) NOT NULL COMMENT '商品名称',
  `type` int(11) NOT NULL COMMENT '商品类型',
  PRIMARY KEY (`idx`),
  KEY `createtime` (`createtime`),
  KEY `seller` (`seller`),
  KEY `buyer` (`buyer`),
  KEY `o_link` (`o_link`),
  KEY `order_id` (`order_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10002 DEFAULT CHARSET=utf8;



--
-- Table structure for table `t_crystal_exchange_record`
--

DROP TABLE IF EXISTS `t_crystal_exchange_record`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_crystal_exchange_record` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT,
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `address` varchar(60) COMMENT 'address',
  `period` int(11) NOT NULL DEFAULT '0' COMMENT '第几期',
  `item_id` int(11) NOT NULL DEFAULT '0' COMMENT '道具id',
  `item_num` bigint NOT NULL DEFAULT '0' COMMENT '道具数量',
  `createtime` int(11) NOT NULL COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_power_exchange_record`
--

DROP TABLE IF EXISTS `t_power_exchange_record`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_power_exchange_record` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT,
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `address` varchar(60) COMMENT 'address',
  `period` int(11) NOT NULL DEFAULT '0' COMMENT '第几期',
  `item_num1` int(11)  NOT NULL DEFAULT '0' COMMENT '晶体道具260001兑换算力数量',
  `item_num2` int(11)  NOT NULL DEFAULT '0' COMMENT '晶体道具260002兑换算力数量',
  `item_num3` int(11)  NOT NULL DEFAULT '0' COMMENT '晶体道具260003兑换算力数量',
  `item_num4` int(11)  NOT NULL DEFAULT '0' COMMENT '晶体道具260004兑换算力数量',
  `total_num` double NOT NULL DEFAULT '0' COMMENT '算力总量',
  `createtime` int(11) NOT NULL COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `t_computing_power_period`
--

DROP TABLE IF EXISTS `t_computing_power_period`;
/*!40101 SET @saved_cs_client      = @@character_set_client */;
/*!40101 SET character_set_client  = utf8 */;
CREATE TABLE `t_hash_rate_reward` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT,
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `address` varchar(60) COMMENT 'address',
  `period` int(11) NOT NULL DEFAULT '0' COMMENT '第几期',
  `power` varchar(60) COMMENT '算力',
  `reward_cec` varchar(60) COMMENT 'reward cec',
  `reward1` int(11) NOT NULL DEFAULT '0' COMMENT '第1周奖励',
  `reward2` int(11) NOT NULL DEFAULT '0' COMMENT '第2周奖励',
  `reward3` int(11) NOT NULL DEFAULT '0' COMMENT '第3周奖励',
  `reward4` int(11) NOT NULL DEFAULT '0' COMMENT '第4周奖励',
  `txHash1` varchar(60) NOT NULL DEFAULT '' COMMENT '地址1',
  `txHash2` varchar(60) NOT NULL DEFAULT '' COMMENT '地址2',
  `txHash3` varchar(60) NOT NULL DEFAULT '' COMMENT '地址3',
  `txHash4` varchar(60) NOT NULL DEFAULT '' COMMENT '地址4',

  `createtime` int(11) NOT NULL COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

CREATE TABLE `t_ranking_settlement_record` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `state` int(11) NOT NULL DEFAULT '0' COMMENT '是否重置',
  `last_rank` int(11) NOT NULL DEFAULT '0' COMMENT '上赛季段位',
  `current_rank` int(11) NOT NULL DEFAULT '0' COMMENT '新段位',
   `last_score` int(11) NOT NULL DEFAULT '0' COMMENT '上赛季段位分',
   `current_score` int(11) NOT NULL DEFAULT '0' COMMENT '新段位分',
   `awards` mediumblob COMMENT '奖励',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id` (`account_id`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;


CREATE TABLE `t_staking` (
  `idx` bigint(20) NOT NULL AUTO_INCREMENT,
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id',
  `address` varchar(60) NOT NULL DEFAULT '' COMMENT 'address',
  `order_id` varchar(60) COMMENT 'order_id',
  `token_id` varchar(60) NOT NULL DEFAULT '' COMMENT 'token_id',
  `item_id` int(11) NOT NULL COMMENT 'item_id',
  `token_type` int(11) NOT NULL DEFAULT '0' COMMENT 'nft类型 1:英雄 2:枪支 3:芯片 6:荣誉 7:徽章',
  `net_id` bigint NOT NULL DEFAULT '0' COMMENT 'net_id',
  `contract_address` varchar(60) NOT NULL DEFAULT '' COMMENT 'contract_address',
  `stacked_num` varchar(60) NOT NULL DEFAULT '' COMMENT 'stacked_num',
  `start_time` bigint NOT NULL DEFAULT '0' COMMENT '质押开始时间',
  `stake_time` bigint NOT NULL DEFAULT '0' COMMENT '质押结束时间',
  `redeem_time` bigint NOT NULL DEFAULT '0' COMMENT '赎回时间',
  `status` int(11) NOT NULL COMMENT '0:质押中 1:已解押',
  `txhash` varchar(255) NOT NULL DEFAULT '' COMMENT 'txhash',
  `nft_type` int(11) NOT NULL COMMENT '',
  `nft_reward` double NOT NULL DEFAULT '0' COMMENT '利息',
  `createtime` int(11) NOT NULL COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `unikey1` (`token_id`, `contract_address`, `net_id`, `start_time`),
  UNIQUE KEY `unikey2` (`token_id`, `contract_address`, `net_id`, `order_id`),
  KEY `address` (`address`)
) ENGINE=InnoDB AUTO_INCREMENT=10000 DEFAULT CHARSET=utf8;

--
-- Table structure for table `t_mail`
--

DROP TABLE IF EXISTS `t_mail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_mail` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `mailid` bigint NOT NULL DEFAULT '0' COMMENT '邮件id',
  `confirmed` int(11) NOT NULL DEFAULT '0' COMMENT 'confirmed',
  `attachments` varchar(255) CHARACTER SET utf8 NOT NULL DEFAULT '' COMMENT '附件',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  KEY `account_id_mailid` (`account_id`, `mailid`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;


--
-- Table structure for table `t_avatar`
--

DROP TABLE IF EXISTS `t_avatar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `t_avatar` (
  `idx` bigint NOT NULL AUTO_INCREMENT COMMENT '自增id',
  `account_id` varchar(60) NOT NULL DEFAULT '' COMMENT '账号id(channel + "_" + gameid + "_" + openid)',
  `token_id` varchar(60) COMMENT 'token_id',
  `item_id` int(11) NOT NULL COMMENT 'item_id',
  `item_type` int(11) NOT NULL  COMMENT 'item类型',
  `status` int(11) NOT NULL DEFAULT '0'  COMMENT '装备状态',
  `hero_idx` bigint DEFAULT NULL COMMENT '英雄外键id',
  `createtime` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `modifytime` int(11) NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`idx`),
  UNIQUE KEY `hero_idx_type` (`hero_idx`, `item_type`)
) ENGINE=InnoDB AUTO_INCREMENT=10001 DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
/*!40101 SET character_set_client = @saved_cs_client */;