<?php

ini_set('date.timezone','UTC');
require 'phpcommon/common.php';
require_once('phpcommon/sqlhelper.php');
require_once('models/BaseModel.php');
require_once('services/BaseService.php');
require_once('constant.php');

function getConfigBaseDir()
{
    return '../res/';
}

function getResBaseDir()
{
    return '../res/';
}

function getXVal($arr, $name, $defVal = null)
{
    if (is_null($arr)) {
        error_log('callstack:' . json_encode(debug_backtrace(), JSON_PRETTY_PRINT));
    }
    $val = array_key_exists($name, $arr) ? $arr[$name] : $defVal;
    return $val;
}

function getReqVal($name, $defVal)
{
    return getXVal($_REQUEST, $name, $defVal);
}

function emptyReplace($val, $defVal)
{
    return !empty($val) ? $val :$defVal;
}

function isValidSex($sex)
{
    return in_array($sex, array(0, 1, 2));
}

function cegFormat($ceg)
{
    return floor($ceg * 100) / 100;
}

function cecFormat($cec)
{
    return floor($cec * 100) / 100;
}

$_myself = null;

function myself()
{
    global $_myself;
    return $_myself;
}

function array_find($arr, $cb)
{
    foreach ($arr as $val) {
        if ($cb($val)) {
            return $val;
        }
    }
    return null;
}

require_once('config_loader.php');

function new_sendError($errcode, $errmsg_tid, $errmsg)
{
    $filename = getResBaseDir() . 'text@text.php';
    if (file_exists($filename)) {
        $g_text_table = require($filename);
        foreach ($g_text_table as $conf) {
            if ($conf['textid'] == $errmsg_tid) {
                $errmsg = $conf['text'];
                break;
            }
        }
    }
    if (empty($errmsg)) {
        $errmsg = $errmsg_tid;
    }
    echo json_encode(array(
        'errcode' => $errcode,
        'errmsg' => $errmsg,
        'errmsg_tid' => $errmsg_tid
    ));
}
