<?php
require_once('models/Emoji.php');

use models\Emoji;
class EmojiController extends BaseAuthedController
{
    public function getEmojiList(){
        $list = Emoji::emojiList();
        $uses = Emoji::getUseEmoji();
        $data = array();
        foreach ($list as $val){
            if(in_array($val,$uses)){
                array_push($data,
                    array(
                        'item_id'=>$val,
                        'state'=>1,
                    )
                );
            }else{
                array_push($data,
                    array(
                        'item_id'=>$val,
                        'state'=>0,
                    )
                );
            }
        }
        $this->_rspData(array(
            'data' => $data,
            'use_emoji' => $uses
        ));
    }

    public function setEmoji(){
        $itemId = getReqVal('item_id', '');
        if(! in_array($itemId,Emoji::emojiList())){
            $this->_rspErr(1, 'item_id parameter error');
            return;
        }
        $uses = Emoji::getUseEmoji();
        if(in_array($itemId,$uses)){
            $this->_rspErr(1, 'The emoji has been used');
            return;
        }
        if(count($uses) >= kMaxEmojiNum){
            $this->_rspErr(1, 'To maximize');
            return;
        }
        array_push($uses,$itemId);
        Emoji::updateEmoji( implode('|',$uses) );
        $this->_rspOk();
    }

    public function cancel(){
        $itemId = getReqVal('item_id', '');
        if(! in_array($itemId,Emoji::emojiList())){
            $this->_rspErr(1, 'item_id parameter error');
            return;
        }
        $uses = Emoji::getUseEmoji();
        if(! in_array($itemId,$uses)){
            $this->_rspErr(1, 'The emoji is not used');
            return;
        }
        foreach ($uses as $k=>$v){
            if ($itemId == $v){
                unset($uses[$k]);
            }
        }
        Emoji::updateEmoji(implode('|',$uses));
        $this->_rspOk();
    }
}