<?php

namespace models;

use mt;
use phpcommon\SqlHelper;

class Battle extends BaseModel {

    public static function find($accountId){
        $row = SqlHelper::ormSelectOne(
            myself()->_getSelfMysql(),
            't_battle',
            array(
                'account_id' => $accountId,
            )
        );
        return $row ? $row : null;
    }

    public static function getMyBattleData()
    {
        $row = SqlHelper::ormSelectOne(
            myself()->_getSelfMysql(),
            't_battle',
            array(
                'account_id' => myself()->_getAccountId(),
            )
        );
        return $row ? json_decode($row['battle_data'], true) : array();
    }

    public static function add($battleData)
    {
        SqlHelper::upsert
            (myself()->_getSelfMysql(),
            't_battle',
             array(
                 'account_id' => myself()->_getAccountId(),
             ),
             array(
                 'battle_data' => $battleData,
                 'modifytime' => myself()->_getNowTime(),
             ),
             array(
                 'account_id' => myself()->_getAccountId(),
                 'battle_data' => $battleData,
                 'kills_modifytime' => myself()->_getNowTime(),
                 'createtime' => myself()->_getNowTime(),
                 'modifytime' => myself()->_getNowTime()
             )
            );
    }

    public static function update($fieldsKv)
    {
        SqlHelper::update
            (myself()->_getSelfMysql(),
            't_battle',
             array(
                 'account_id' => myself()->_getAccountId(),
             ),
             $fieldsKv
            );
    }

}
