<?php

namespace models;

use phpcommon\SqlHelper;

class BcOrder {

    const NORMAL_ORDER_TYPE = 0;
    const SPEC_ORDER_TYPE = 1;

    const SHOP_BUY_MODE_NORMAL = 0;
    const MARKET_BUY_MODE_NORMAL = 1;

    public static function find($orderId){
        $row = SqlHelper::ormSelectOne(
            myself()->_getMysql(''),
            't_bc_order',
            array(
                'order_id' => $orderId
            )
        );
        return $row;
    }

    public static function upsert($orderId, $fieldsKv){
        SqlHelper::upsert
            (myself()->_getSelfMysql(),
             't_bc_order',
             array(
                 'order_id' => $orderId
             ),
             array(
             ),
             array(
                 'order_id' => $orderId,
                 'order_type' => getXVal($fieldsKv,'order_type',0),
                 'account_id' => myself()->_getAccountId(),
                 'address' => myself()->_getAddress(),
                 'status' => 0,
                 'item_id' => $fieldsKv['item_id'],
                 'item_num' => $fieldsKv['item_num'],
                 'ext_data' => getXVal($fieldsKv,'ext_data',''),
                 'createtime' => myself()->_getNowTime(),
                 'modifytime' => myself()->_getNowTime(),
                 'price' => $fieldsKv['price'],
             )
            );
    }

    public static function update($orderId, $fieldsKv){
        SqlHelper::update
            (myself()->_getMysql(''),
             't_bc_order',
             array(
                 'order_id' => $orderId
             ),
             $fieldsKv
            );
    }

}
