<?php

namespace models;

use mt;
use phpcommon\SqlHelper;

class BoxOrder extends BaseModel {

    const MAX_NFT_NUM = 3;

    public function getSoldNum($batchIdx)
    {
        $row = myself()->_getMarketMysql()->execQueryOne
             ('SELECT COUNT(*) AS sold_num FROM t_box_order WHERE batch_idx=:batch_idx AND ' .
              ' (bc_paid = 1 OR done <> 1);',
              array(
                  ':batch_idx' => $batchIdx
              ));
        return $row && $row['sold_num'] ? (int)$row['sold_num'] : 0;
    }

    public function isBuyed($buyerAddress, $batchIdx)
    {
        $row = myself()->_getMarketMysql()->execQueryOne
             ('SELECT COUNT(*) AS buy_count FROM t_box_order WHERE batch_idx=:batch_idx AND ' .
              '  buyer_address=:buyer_address AND (bc_paid = 1 OR done <> 1);',
              array(
                  ':buyer_address' => $buyerAddress,
                  ':batch_idx' => $batchIdx
              ));
        return $row && $row['buy_count'] ? $row['buy_count'] > 0 : false;
    }

    public function findByOrderId($orderId)
    {
        $row = SqlHelper::ormSelectOne(
            myself()->_getMarketMysql(),
            't_box_order',
            array(
                'order_id' => $orderId,
            )
        );
        return $row;
    }

}
