<?php

namespace models;

use mt;
use phpcommon\SqlHelper;

class GunSkin extends BaseModel {

    const GETED_STATE = 0;
    const TRY_USING_STATE = 1;

    public static function find($skinId)
    {
        $row = SqlHelper::ormSelectOne(
            myself()->_getSelfMysql(),
            't_gun_skin',
            array(
                'account_id' => myself()->_getAccountId(),
                'skin_id' => $skinId
            )
        );
        return $row;
    }

    public static function toDto($row)
    {
        return array(
            'skin_id' => $row['skin_id'],
            'skin_state' => $row['skin_state'],
            'try_expire_at' => $row['try_expire_at'],
            'chip_ids' => $row['chip_ids'],
        );
    }

    public static function addSkin($skinId)
    {
        SqlHelper::upsert(
            myself()->_getSelfMysql(),
            't_gun_skin',
            array(
                'account_id' => myself()->_getAccountId(),
                'skin_id' => $skinId
            ),
            array(
                'skin_state' => self::GETED_STATE,
                'modifytime' => myself()->_getNowTime()
            ),
            array(
                'account_id' => myself()->_getAccountId(),
                'skin_id' => $skinId,
                'skin_state' => self::GETED_STATE,
                'try_expire_at' => 0,
                'createtime' => myself()->_getNowTime(),
                'modifytime' => myself()->_getNowTime()
            )
        );
    }

}
