<?php

namespace models;

use mt;
use phpcommon\SqlHelper;

class OutAppOrder extends BaseModel {

    const PENDING_STATE = 0;
    const FINISHED_STATE = 1;
    const FAILED_STATE = 2;

    public static function find($orderId)
    {
        $row = SqlHelper::ormSelectOne(
            myself()->_getMysql(''),
            't_outapp_order',
            array(
                'order_id' => $orderId,
            )
        );
        return $row;
    }

    public static function add($orderId, $platform, $goodsId, $price, $paramsJson)
    {
        SqlHelper::insert(
            myself()->_getMysql(''),
            't_outapp_order',
            array(
                'order_id' => $orderId,
                'account_id' => myself()->_getAccountId(),
                'platform' => $platform,
                'goods_id' => $goodsId,
                'price' => $price,
                'params' => $paramsJson,
                'createtime' => myself()->_getNowTime(),
                'modifytime' => myself()->_getNowTime(),
            )
        );
    }

    public static function markFinished($orderId)
    {
        SqlHelper::update(
            myself()->_getMysql(''),
            't_outapp_order',
            array(
                'order_id' => $orderId,
            ),
            array(
                'status' => self::FINISHED_STATE,
            )
        );
    }

    public static function markFailed($orderId)
    {
        SqlHelper::update(
            myself()->_getMysql(''),
            't_outapp_order',
            array(
                'order_id' => $orderId,
            ),
            array(
                'status' => self::FAILED_STATE,
            )
        );
    }

}
