<?php

namespace models;

require_once('mt/SeasonCard.php');

use mt;
use phpcommon\SqlHelper;

class Season extends BaseModel {

    public static function find($seasonId)
    {
        $row = SqlHelper::ormSelectOne(
            myself()->_getSelfMysql(),
            't_season',
            array(
                'account_id' => myself()->_getAccountId(),
                'season_id' => $seasonId,
            )
        );
        return $row;
    }

    public static function findByAccount($accountId,$seasonId)
    {
        $row = SqlHelper::ormSelectOne(
            myself()->_getSelfMysql(),
            't_season',
            array(
                'account_id' => $accountId,
                'season_id' => $seasonId,
            )
        );
        return $row;
    }

    public static function toDto($row)
    {
        return array(
        );
    }

    public static function seasonReward($rankMeta)
    {
        $rewardList = array();
        if (!$rankMeta){
            return $rewardList;
        }
        $rewards = explode('|',$rankMeta['reward']);
        foreach ($rewards as $reward){
            $temp = explode(',',$reward);
            array_push($rewardList,array(
                'item_id' => $temp[0],
                'item_num' => $temp[1]?$temp[1]:1,
            ));
        }
        return  $rewardList;
    }

    public static function add($seasonId)
    {
        $initSeasonCard = mt\SeasonCard::getInitCard();
        SqlHelper::upsert(
            myself()->_getSelfMysql(),
            't_season',
            array(
                'account_id' => myself()->_getAccountId(),
                'season_id' => $seasonId,
            ),
            array(
            ),
            array(
                'account_id' => myself()->_getAccountId(),
                'season_id' => $seasonId,
                'card_lv' => $initSeasonCard ? $initSeasonCard['lv'] : 1,
                'card_exp' => $initSeasonCard ? $initSeasonCard['min_exp'] : 0,
                'kills_modifytime' => myself()->_getNowTime(),
                'score_modifytime' => myself()->_getNowTime(),
                'best_rank_modifytime' => myself()->_getNowTime(),
                'createtime' => myself()->_getNowTime(),
                'modifytime' => myself()->_getNowTime()
            )
        );
    }

    public static function getHistorySeasons($targetId)
    {
        $rows = SqlHelper::ormSelect(
            myself()->_getMysql($targetId),
            't_season',
            array(
                'account_id' => $targetId,
            )
        );
        return $rows;
    }

    public static function updateGiftPackageState($seasonId, $packageId)
    {
        if (in_array($packageId, array(
            1,
            2
        ))) {
            SqlHelper::update(
                myself()->_getSelfMysql(),
                't_season',
                array(
                    'account_id' => myself()->_getAccountId(),
                    'season_id' => $seasonId,
                ),
                array(
                    "gift_state${packageId}" => 1,
                    "gift_buytime${packageId}" => myself()->_getNowTime()
                )
            );
        }
    }

    public static function updateCardLv($seasonId, $cardLv)
    {

        SqlHelper::update(
            myself()->_getSelfMysql(),
            't_season',
            array(
                'account_id' => myself()->_getAccountId(),
                'season_id' => $seasonId,
            ),
            array(
                "card_lv" => $cardLv,
            )
        );
    }

    public static function upsert($seasonId, $fieldsKv)
    {

        SqlHelper::upsert(
            myself()->_getSelfMysql(),
            't_season',
            array(
                'account_id' => myself()->_getAccountId(),
                'season_id' => $seasonId,
            ),
            $fieldsKv,
            array(
                'account_id' => myself()->_getAccountId(),
                'season_id' => $seasonId,
                'card_lv' => 1,
                'card_exp' =>  0,
                'battle_data' =>  isset($fieldsKv['battle_data']) ? $fieldsKv['battle_data'] : '',
                'kills_modifytime' => myself()->_getNowTime(),
                'score_modifytime' => myself()->_getNowTime(),
                'best_rank_modifytime' => myself()->_getNowTime(),
                'createtime' => myself()->_getNowTime(),
                'modifytime' => myself()->_getNowTime()
            )
        );
    }

}
