<?php

namespace mt;

require_once('mt/AttrHelper.php');
require_once('mt/StrHelper.php');

use phpcommon;

class ChipQuality {

    public static function get($id)
    {
        return getXVal(self::getMetaList(), $id);
    }

    public static function getByQuality($quality)
    {
        self::mustBeQualityHash();
        return getXVal(self::$qualityHash, $quality, null);
    }

    public static function getRandAttr($qualityMeta)
    {
        $nums = explode(':', $qualityMeta['rand_attrs_num']);
        $attrs = StrHelper::parseList($qualityMeta['rand_attrs'], array('|', ':'));
        $num = rand($nums[0], $nums[1]);
        shuffle($attrs);
        $result = array();
        $i = 0;
        foreach ($attrs as $item) {
            if ($i < $num) {
                array_push($result,
                           array(
                               'attr_id' => $item[0],
                               'type' => $item[1],
                               'val' => rand($item[2], $item[3])
                           ));
            }
            ++$i;
        }
        return $result;
    }

    protected static function getMetaList()
    {
        if (!self::$metaList) {
            self::$metaList = getMetaTable('chipQuality@chipQuality.php');
        }
        return self::$metaList;
    }

    protected static function mustBeQualityHash()
    {
        if (!self::$qualityHash) {
            self::$qualityHash = array();
            foreach (self::getMetaList() as $meta) {
                self::$qualityHash[$meta['quality']] = $meta;
            }
        }
    }

    protected static $metaList;
    protected static $qualityHash;

}
