<?php

namespace mt;

use phpcommon;

class NftDesc {

    public static function get($id)
    {
        return array_key_exists($id, self::getMetaList()) ? self::getMetaList()[$id] : null;
    }

    public static function getByItemId($itemId)
    {
        self::mustBeItemIdHash();
        return array_key_exists($itemId, self::$itemIdHash) ? self::$itemIdHash[$itemId] : null;
    }

    protected static function getMetaList()
    {
        if (!self::$metaList) {
            self::$metaList = getMetaTable('Nftdesc@Nftdesc.php');
        }
        return self::$metaList;
    }

    protected static function mustBeItemIdHash()
    {
        if (!self::$itemIdHash) {
            self::$itemIdHash = array();
            foreach (self::getMetaList() as $meta) {
                self::$itemIdHash[$meta['item_id']] = $meta;
            }
        }
    }

    protected static $metaList;
    protected static $itemIdHash;

}
