<?php

namespace mt;

use phpcommon;

class Shop {

    const TOKEN_TYPE_GOLD = '0';
    const TOKEN_TYPE_CEG = '1';
    const TOKEN_TYPE_CEC = '2';
    const TOKEN_TYPE_BCEG = '3';
    const TOKEN_TYPE_DIAMOND = '4';


    const TOKEN_TYPE_USDT = '11';
    const TOKEN_TYPE_USDC = '12';
    const TOKEN_TYPE_BUSD = '13';

    const TOKEN_TYPE_MATIC = '101';
    const TOKEN_TYPE_BNB = '102';

    //99 = 美元
    const TOKEN_TYPE_USD = '99';

    //21 = 印尼
    const TOKEN_TYPE_IDR = '21';
    //22 = 菲律宾
    const TOKEN_TYPE_PHP = '22';
    //23 = 越南
    const TOKEN_TYPE_VND = '23';
    //24 = 泰国
    const TOKEN_TYPE_THB = '24';
    //25 = 马来西亚
    const TOKEN_TYPE_MYR = '25';
    //26 = 日本
    const TOKEN_TYPE_JPY = '26';
    //27 = 韩国
    const TOKEN_TYPE_KRW = '27';

    // 限购类型
    const DAILY_BUY_LIMIT = 1;
    const WEEKLY_BUY_LIMIT = 2;
    const TOTAL_BUY_LIMIT = 3;

    const OUTAPP_SHOP = 7;
    const INAPP_SHOP_DIAMOND = 9;

    const OUTSIDE_SHOP = 100;

    public static function getCostItemIdByTokenType($tokenType)
    {
        switch ($tokenType) {
        case self::TOKEN_TYPE_GOLD:
        {
            return V_ITEM_GOLD;
        }
        break;
        case self::TOKEN_TYPE_DIAMOND:
        {
            return V_ITEM_DIAMOND;
        }
        break;
        default:
        {
            return -1;
        }
        break;
        }
    }

    public static function get($id)
    {
        return getXVal(self::getMetaList(), $id);
    }

    public static function all()
    {
        if (!self::$shopNameList) {
            self::$shopNameList = array();
            foreach(self::getMetaList() as $meta) {
                array_push(self::$shopNameList, $meta);
            }
        }

        return self::$shopNameList;
    }

    protected static function getMetaList()
    {
        if (!self::$metaList) {
            self::$metaList = getMetaTable('shop@shop.php');
        }
        return self::$metaList;
    }

    protected static $shopNameList;
    protected static $metaList;

}
